/*
 * Copyright (C) 2017, Thomas Maier-Komor (maier-komor.de)
 * 
 * Code generated with Wire-Format-Compiler V0.2.0/hg:afdb8c6821e9
 * License ID: 17491
 */

/********************************************************************************
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/


/*
 * options from commandline:
 * 
 * options from file:hostscope.wfc:
 * toASCII         : ""
 * toWire          : ""
 * 
 * options from defaults:
 * AddPrefix       : "add_"
 * bytestype       : "std"
 * ClearName       : "clear"
 * ClearPrefix     : "clear_"
 * endian          : "unknown"
 * fromMemory      : "fromMemory"
 * GetPrefix       : ""
 * HasPrefix       : "has_"
 * intsize         : 32
 * MutablePrefix   : "mutable_"
 * namespace       : ""
 * SetPrefix       : "set_"
 * SortMembers     : "id"
 * stringtype      : "std"
 * syntax          : "xprotov1"
 * toMemory        : "toMemory"
 * unknown         : "skip"
 * VarIntBits      : 64
 * wireput         : ""
 * 
 * disabled flags from defaults:
 * 	cc_generic_services, checks, Debug, SubClasses, withEqual, withUnequal
 * enabled flags from defaults:
 * 	Asserts, StringSerialization
 */

#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include "hostscope_wfc.h"

int varint2wire(void (*put)(uint8_t), varint_t v)
{
	int n = 0;
	do {
		uint8_t u8 = v & 0x7f;
		v >>= 7;
		if (v)
			u8 |= 0x80;
		put(u8);
		++n;
	} while (v);
	return n;
}

int varint2mem(uint8_t *mem, signed ml, varint_t v)
{
	uint8_t *m = mem, *e = mem + ml;
	do {
		if (m >= e)
			return 0;
		uint8_t u8 = v & 0x7f;
		v >>= 7;
		if (v)
			u8 |= 0x80;
		*m = u8;
		++m;
	} while (v);
	return m-mem;
}

int wire2varint(const uint8_t *wire, signed wl, varint_t *r)
{
	uint8_t u8;
	int n = 0;
	*r = 0;
	do {
		if (wl-- <= 0)
			return 0;
		u8 = *wire++;
		*r |= (uint64_t)(u8&~0x80) << (n*7);
		++n;
	} while ((u8 & 0x80) && (n < 10));
	return n;
}

unsigned skip_field_xproto(const uint8_t *wire, size_t wl)
{
	if (wl <= 0)
		return 0;
	unsigned n = 1;
	switch (*wire++&0x7) {
	case 0:
		while (--wl && (*wire++&0x80)) ++n;
			return n;
	case 1:
		if (wl < 9)
			return wl;
		return 9;
	case 2: {
			varint_t l = 0;
			n = wire2varint(wire,wl,&l);
			if (n == 0)
				return wl;
			l += n + 1;
			if (l < wl)
				return l;
			return wl;
		}
	case 3:
		if (wl < 2)
			return wl;
		return 2;
	case 4:
		if (wl < 3)
			return wl;
		return 3;
	case 5:
		if (wl < 5)
			return wl;
		return 5;
	default:
		assert(0);
	}
}

#if defined __BYTE_ORDER__ && __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define read_u16(wire) (*(uint16_t *)(wire))
#define read_u32(wire) (*(uint32_t *)(wire))
#define read_u64(wire) (*(uint64_t *)(wire))
#define read_float(wire) (*(float *)(wire))
#define read_double(wire) (*(double *)(wire))
#else
uint16_t read_u16(const uint8_t *wire)
{
	uint16_t r;
	r = (uint16_t)*wire++;
	r |= (uint16_t)*wire++ << 8;
	return r;
}

uint32_t read_u32(const uint8_t *wire)
{
	uint32_t r;
	r = (uint32_t)*wire++;
	r |= (uint32_t)*wire++ << 8;
	r |= (uint32_t)*wire++ << 16;
	r |= (uint32_t)*wire << 24;
	return r;
}

uint64_t read_u64(const uint8_t *wire)
{
	uint64_t r;
	r = (uint64_t)*wire++;
	r |= (uint64_t)*wire++ << 8;
	r |= (uint64_t)*wire++ << 16;
	r |= (uint64_t)*wire++ << 24;
	r |= (uint64_t)*wire++ << 32;
	r |= (uint64_t)*wire++ << 40;
	r |= (uint64_t)*wire++ << 48;
	r |= (uint64_t)*wire << 56;
	return r;
}

float read_float(const uint8_t *wire)
{
	union { uint32_t i; float f; } r;
	r.i = (uint32_t)*wire++;
	r.i |= (uint32_t)*wire++ << 8;
	r.i |= (uint32_t)*wire++ << 16;
	r.i |= (uint32_t)*wire << 24;
	return r.f;
}

double read_double(const uint8_t *wire)
{
	union { uint64_t i; double d; } r;
	r.i = (uint64_t)*wire++;
	r.i |= (uint64_t)*wire++ << 8;
	r.i |= (uint64_t)*wire++ << 16;
	r.i |= (uint64_t)*wire++ << 24;
	r.i |= (uint64_t)*wire++ << 32;
	r.i |= (uint64_t)*wire++ << 40;
	r.i |= (uint64_t)*wire++ << 48;
	r.i |= (uint64_t)*wire << 56;
	return r.d;
}
#endif

HostScope::HostScope()
: m_metadata()
, m_hostinfo()
, m_loadavg()
, m_mem()
, m_power_supplies()
, m_linux_info()
, m_linux_vmstat()
, m_linux_cpus()
, m_processes()
, m_users()
, m_disks()
, m_netdevices()
, p_validbits(0)
{
}

void HostScope::clear()
{
	m_metadata.clear();
	m_hostinfo.clear();
	m_loadavg.clear();
	m_mem.clear();
	m_power_supplies.clear();
	m_linux_info.clear();
	m_linux_vmstat.clear();
	m_linux_cpus.clear();
	m_processes.clear();
	m_users.clear();
	m_disks.clear();
	m_netdevices.clear();
	p_validbits = 0;
}

size_t HostScope::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0xa:	// metadata id 1, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_metadata.fromMemory((const char*)a,v);
				a += v;
			}
			break;
		case 0x12:	// hostinfo id 2, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_hostinfo.fromMemory((const char*)a,v);
				a += v;
			}
			break;
		case 0x1a:	// loadavg id 3, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_loadavg.fromMemory((const char*)a,v);
				a += v;
			}
			p_validbits |= ((uint8_t)1U << 0);
			break;
		case 0x22:	// mem id 4, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_mem.fromMemory((const char*)a,v);
				a += v;
			}
			p_validbits |= ((uint8_t)1U << 1);
			break;
		case 0x2a:	// power_supplies id 5, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_power_supplies.resize(m_power_supplies.size()+1);
				m_power_supplies.back().fromMemory((const char*)a,v);
				a += v;
			}
			break;
		case 0x42:	// linux_info id 8, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_linux_info.fromMemory((const char*)a,v);
				a += v;
			}
			p_validbits |= ((uint8_t)1U << 2);
			break;
		case 0x4a:	// linux_vmstat id 9, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_linux_vmstat.fromMemory((const char*)a,v);
				a += v;
			}
			p_validbits |= ((uint8_t)1U << 3);
			break;
		case 0x52:	// linux_cpus id 10, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_linux_cpus.resize(m_linux_cpus.size()+1);
				m_linux_cpus.back().fromMemory((const char*)a,v);
				a += v;
			}
			break;
		case 0x62:	// processes id 12, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_processes.resize(m_processes.size()+1);
				m_processes.back().fromMemory((const char*)a,v);
				a += v;
			}
			break;
		case 0x82:	// users id 16, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_users.resize(m_users.size()+1);
				m_users.back().fromMemory((const char*)a,v);
				a += v;
			}
			break;
		case 0x8a:	// disks id 17, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_disks.resize(m_disks.size()+1);
				m_disks.back().fromMemory((const char*)a,v);
				a += v;
			}
			break;
		case 0x92:	// netdevices id 18, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_netdevices.resize(m_netdevices.size()+1);
				m_netdevices.back().fromMemory((const char*)a,v);
				a += v;
			}
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope::calcSize() const
{
	// metadata: tagsize 1
	// hostinfo: tagsize 1
	size_t r = 2;	// required size, default is fixed length
	size_t metadata_s = m_metadata.calcSize();
	r += metadata_s + wiresize_u64(metadata_s);
	size_t hostinfo_s = m_hostinfo.calcSize();
	r += hostinfo_s + wiresize_u64(hostinfo_s);
	if (has_loadavg()) {
		size_t loadavg_s = m_loadavg.calcSize();
		r += loadavg_s + wiresize_u64(loadavg_s) + 1 /* tag(id) 0x18 */;
	}
	if (has_mem()) {
		size_t mem_s = m_mem.calcSize();
		r += mem_s + wiresize_u64(mem_s) + 1 /* tag(id) 0x20 */;
	}
	if (!m_power_supplies.empty()) {
		// repeated message power_supplies
		for (size_t x = 0, y = m_power_supplies.size(); x < y; ++x) {
			size_t s = m_power_supplies[x].calcSize();
			r += wiresize_u64(s);
			r += s + 1 /* tag(id) 0x28 */;
		}
	}
	if (has_linux_info()) {
		size_t linux_info_s = m_linux_info.calcSize();
		r += linux_info_s + wiresize_u64(linux_info_s) + 1 /* tag(id) 0x40 */;
	}
	if (has_linux_vmstat()) {
		size_t linux_vmstat_s = m_linux_vmstat.calcSize();
		r += linux_vmstat_s + wiresize_u64(linux_vmstat_s) + 1 /* tag(id) 0x48 */;
	}
	if (!m_linux_cpus.empty()) {
		// repeated message linux_cpus
		for (size_t x = 0, y = m_linux_cpus.size(); x < y; ++x) {
			size_t s = m_linux_cpus[x].calcSize();
			r += wiresize_u64(s);
			r += s + 1 /* tag(id) 0x50 */;
		}
	}
	if (!m_processes.empty()) {
		// repeated message processes
		for (size_t x = 0, y = m_processes.size(); x < y; ++x) {
			size_t s = m_processes[x].calcSize();
			r += wiresize_u64(s);
			r += s + 1 /* tag(id) 0x60 */;
		}
	}
	if (!m_users.empty()) {
		// repeated message users
		for (size_t x = 0, y = m_users.size(); x < y; ++x) {
			size_t s = m_users[x].calcSize();
			r += wiresize_u64(s);
			r += s + 2 /* tag(id) 0x80 */;
		}
	}
	if (!m_disks.empty()) {
		// repeated message disks
		for (size_t x = 0, y = m_disks.size(); x < y; ++x) {
			size_t s = m_disks[x].calcSize();
			r += wiresize_u64(s);
			r += s + 2 /* tag(id) 0x88 */;
		}
	}
	if (!m_netdevices.empty()) {
		// repeated message netdevices
		for (size_t x = 0, y = m_netdevices.size(); x < y; ++x) {
			size_t s = m_netdevices[x].calcSize();
			r += wiresize_u64(s);
			r += s + 2 /* tag(id) 0x90 */;
		}
	}
	return r;
}

size_t HostScope::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'metadata': id=1, encoding=2, tag=0xa
	a += varint2mem(a,e-a,0xa);	// 'metadata': id=1
	a += varint2mem(a,e-a,m_metadata.calcSize());
	a += m_metadata.toMemory(a,e-a);
	// 'hostinfo': id=2, encoding=2, tag=0x12
	a += varint2mem(a,e-a,0x12);	// 'hostinfo': id=2
	a += varint2mem(a,e-a,m_hostinfo.calcSize());
	a += m_hostinfo.toMemory(a,e-a);
	if (has_loadavg()) {
		// 'loadavg': id=3, encoding=2, tag=0x1a
		a += varint2mem(a,e-a,0x1a);	// 'loadavg': id=3
		a += varint2mem(a,e-a,m_loadavg.calcSize());
		a += m_loadavg.toMemory(a,e-a);
	}
	if (has_mem()) {
		// 'mem': id=4, encoding=2, tag=0x22
		a += varint2mem(a,e-a,0x22);	// 'mem': id=4
		a += varint2mem(a,e-a,m_mem.calcSize());
		a += m_mem.toMemory(a,e-a);
	}
	for (size_t x = 0, y = m_power_supplies.size(); x != y; ++x) {
		// 'power_supplies': id=5, encoding=2, tag=0x2a
		a += varint2mem(a,e-a,0x2a);	// 'power_supplies': id=5
		a += varint2mem(a,e-a,m_power_supplies[x].calcSize());
		a += m_power_supplies[x].toMemory(a,e-a);
	}
	if (has_linux_info()) {
		// 'linux_info': id=8, encoding=2, tag=0x42
		a += varint2mem(a,e-a,0x42);	// 'linux_info': id=8
		a += varint2mem(a,e-a,m_linux_info.calcSize());
		a += m_linux_info.toMemory(a,e-a);
	}
	if (has_linux_vmstat()) {
		// 'linux_vmstat': id=9, encoding=2, tag=0x4a
		a += varint2mem(a,e-a,0x4a);	// 'linux_vmstat': id=9
		a += varint2mem(a,e-a,m_linux_vmstat.calcSize());
		a += m_linux_vmstat.toMemory(a,e-a);
	}
	for (size_t x = 0, y = m_linux_cpus.size(); x != y; ++x) {
		// 'linux_cpus': id=10, encoding=2, tag=0x52
		a += varint2mem(a,e-a,0x52);	// 'linux_cpus': id=10
		a += varint2mem(a,e-a,m_linux_cpus[x].calcSize());
		a += m_linux_cpus[x].toMemory(a,e-a);
	}
	for (size_t x = 0, y = m_processes.size(); x != y; ++x) {
		// 'processes': id=12, encoding=2, tag=0x62
		a += varint2mem(a,e-a,0x62);	// 'processes': id=12
		a += varint2mem(a,e-a,m_processes[x].calcSize());
		a += m_processes[x].toMemory(a,e-a);
	}
	for (size_t x = 0, y = m_users.size(); x != y; ++x) {
		// 'users': id=16, encoding=2, tag=0x82
		a += varint2mem(a,e-a,0x82);	// 'users': id=16
		a += varint2mem(a,e-a,m_users[x].calcSize());
		a += m_users[x].toMemory(a,e-a);
	}
	for (size_t x = 0, y = m_disks.size(); x != y; ++x) {
		// 'disks': id=17, encoding=2, tag=0x8a
		a += varint2mem(a,e-a,0x8a);	// 'disks': id=17
		a += varint2mem(a,e-a,m_disks[x].calcSize());
		a += m_disks[x].toMemory(a,e-a);
	}
	for (size_t x = 0, y = m_netdevices.size(); x != y; ++x) {
		// 'netdevices': id=18, encoding=2, tag=0x92
		a += varint2mem(a,e-a,0x92);	// 'netdevices': id=18
		a += varint2mem(a,e-a,m_netdevices[x].calcSize());
		a += m_netdevices[x].toMemory(a,e-a);
	}
	assert(a <= e);
	return a-b;
}

const HostScope_MetaData & HostScope::metadata() const
{ return m_metadata; }

HostScope_MetaData *HostScope::mutable_metadata()
{ return &m_metadata; }

void HostScope::set_metadata(const HostScope_MetaData & v)
{ m_metadata = v; }

const HostScope_HostInfo & HostScope::hostinfo() const
{ return m_hostinfo; }

HostScope_HostInfo *HostScope::mutable_hostinfo()
{ return &m_hostinfo; }

void HostScope::set_hostinfo(const HostScope_HostInfo & v)
{ m_hostinfo = v; }

const HostScope_LoadAvg & HostScope::loadavg() const
{ return m_loadavg; }

HostScope_LoadAvg *HostScope::mutable_loadavg()
{
	if (0 == (p_validbits & ((uint8_t)1U << 0))) {
		m_loadavg.clear();
		p_validbits |= ((uint8_t)1U << 0);
	}
	return &m_loadavg;
}

void HostScope::set_loadavg(const HostScope_LoadAvg & v)
{
	m_loadavg = v;
	p_validbits |= ((uint8_t)1U << 0);
}

const HostScope_Memory & HostScope::mem() const
{ return m_mem; }

HostScope_Memory *HostScope::mutable_mem()
{
	if (0 == (p_validbits & ((uint8_t)1U << 1))) {
		m_mem.clear();
		p_validbits |= ((uint8_t)1U << 1);
	}
	return &m_mem;
}

void HostScope::set_mem(const HostScope_Memory & v)
{
	m_mem = v;
	p_validbits |= ((uint8_t)1U << 1);
}

const HostScope_PowerSupply & HostScope::power_supplies(unsigned x) const
{
	return m_power_supplies[x];
}

HostScope_PowerSupply *HostScope::add_power_supplies()
{
	m_power_supplies.resize(m_power_supplies.size()+1);
	return &m_power_supplies.back();
}

HostScope_PowerSupply *HostScope::mutable_power_supplies(unsigned x)
{
	if (x >= m_power_supplies.size())
		m_power_supplies.resize(x+1);
	return &m_power_supplies[x];
}

void HostScope::set_power_supplies(unsigned x, const HostScope_PowerSupply &v)
{
	assert(x < m_power_supplies.size());
	m_power_supplies[x] = v;
}

void HostScope::clear_power_supplies()
{ m_power_supplies.clear(); }

const HostScope_LinuxInfo & HostScope::linux_info() const
{ return m_linux_info; }

HostScope_LinuxInfo *HostScope::mutable_linux_info()
{
	if (0 == (p_validbits & ((uint8_t)1U << 2))) {
		m_linux_info.clear();
		p_validbits |= ((uint8_t)1U << 2);
	}
	return &m_linux_info;
}

void HostScope::set_linux_info(const HostScope_LinuxInfo & v)
{
	m_linux_info = v;
	p_validbits |= ((uint8_t)1U << 2);
}

const HostScope_LinuxVmstat & HostScope::linux_vmstat() const
{ return m_linux_vmstat; }

HostScope_LinuxVmstat *HostScope::mutable_linux_vmstat()
{
	if (0 == (p_validbits & ((uint8_t)1U << 3))) {
		m_linux_vmstat.clear();
		p_validbits |= ((uint8_t)1U << 3);
	}
	return &m_linux_vmstat;
}

void HostScope::set_linux_vmstat(const HostScope_LinuxVmstat & v)
{
	m_linux_vmstat = v;
	p_validbits |= ((uint8_t)1U << 3);
}

const HostScope_LinuxCPU & HostScope::linux_cpus(unsigned x) const
{
	return m_linux_cpus[x];
}

HostScope_LinuxCPU *HostScope::add_linux_cpus()
{
	m_linux_cpus.resize(m_linux_cpus.size()+1);
	return &m_linux_cpus.back();
}

HostScope_LinuxCPU *HostScope::mutable_linux_cpus(unsigned x)
{
	if (x >= m_linux_cpus.size())
		m_linux_cpus.resize(x+1);
	return &m_linux_cpus[x];
}

void HostScope::set_linux_cpus(unsigned x, const HostScope_LinuxCPU &v)
{
	assert(x < m_linux_cpus.size());
	m_linux_cpus[x] = v;
}

void HostScope::clear_linux_cpus()
{ m_linux_cpus.clear(); }

const HostScope_Process & HostScope::processes(unsigned x) const
{
	return m_processes[x];
}

HostScope_Process *HostScope::add_processes()
{
	m_processes.resize(m_processes.size()+1);
	return &m_processes.back();
}

HostScope_Process *HostScope::mutable_processes(unsigned x)
{
	if (x >= m_processes.size())
		m_processes.resize(x+1);
	return &m_processes[x];
}

void HostScope::set_processes(unsigned x, const HostScope_Process &v)
{
	assert(x < m_processes.size());
	m_processes[x] = v;
}

void HostScope::clear_processes()
{ m_processes.clear(); }

const HostScope_User & HostScope::users(unsigned x) const
{
	return m_users[x];
}

HostScope_User *HostScope::add_users()
{
	m_users.resize(m_users.size()+1);
	return &m_users.back();
}

HostScope_User *HostScope::mutable_users(unsigned x)
{
	if (x >= m_users.size())
		m_users.resize(x+1);
	return &m_users[x];
}

void HostScope::set_users(unsigned x, const HostScope_User &v)
{
	assert(x < m_users.size());
	m_users[x] = v;
}

void HostScope::clear_users()
{ m_users.clear(); }

const HostScope_Disk & HostScope::disks(unsigned x) const
{
	return m_disks[x];
}

HostScope_Disk *HostScope::add_disks()
{
	m_disks.resize(m_disks.size()+1);
	return &m_disks.back();
}

HostScope_Disk *HostScope::mutable_disks(unsigned x)
{
	if (x >= m_disks.size())
		m_disks.resize(x+1);
	return &m_disks[x];
}

void HostScope::set_disks(unsigned x, const HostScope_Disk &v)
{
	assert(x < m_disks.size());
	m_disks[x] = v;
}

void HostScope::clear_disks()
{ m_disks.clear(); }

const HostScope_NetDevice & HostScope::netdevices(unsigned x) const
{
	return m_netdevices[x];
}

HostScope_NetDevice *HostScope::add_netdevices()
{
	m_netdevices.resize(m_netdevices.size()+1);
	return &m_netdevices.back();
}

HostScope_NetDevice *HostScope::mutable_netdevices(unsigned x)
{
	if (x >= m_netdevices.size())
		m_netdevices.resize(x+1);
	return &m_netdevices[x];
}

void HostScope::set_netdevices(unsigned x, const HostScope_NetDevice &v)
{
	assert(x < m_netdevices.size());
	m_netdevices[x] = v;
}

void HostScope::clear_netdevices()
{ m_netdevices.clear(); }

HostScope_MetaData::HostScope_MetaData()
: m_protocol_version(0)
, m_timestamp(0)
, m_hostscope_version()
{
}

void HostScope_MetaData::clear()
{
	m_protocol_version = 0;
	m_timestamp = 0;
	m_hostscope_version.clear();
}

size_t HostScope_MetaData::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0x8:	// protocol_version id 1, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_protocol_version = (uint32_t)v;
			}
			break;
		case 0xb:	// protocol_version id 1, coding 8bit
			m_protocol_version = (uint32_t)*a++;
			break;
		case 0xc:	// protocol_version id 1, coding 16bit
			get_u16(a,(uint16_t*)&m_protocol_version);
			a += 2;
			break;
		case 0xd:	// protocol_version id 1, coding: 32bit
			get_u32(a,(uint32_t*)&m_protocol_version);
			a += 4;
			break;
		case 0x10:	// timestamp id 2, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_timestamp = (uint64_t)v;
			}
			break;
		case 0x13:	// timestamp id 2, coding 8bit
			m_timestamp = (uint64_t)*a++;
			break;
		case 0x14:	// timestamp id 2, coding 16bit
			get_u16(a,(uint16_t*)&m_timestamp);
			a += 2;
			break;
		case 0x15:	// timestamp id 2, coding: 32bit
			get_u32(a,(uint32_t*)&m_timestamp);
			a += 4;
			break;
		case 0x1a:	// hostscope_version id 3, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_hostscope_version.assign((const char*)a,v);
				a += v;
			}
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_MetaData::calcSize() const
{
	// protocol_version: tagsize 1
	// timestamp: tagsize 1
	// hostscope_version: tagsize 1
	size_t r = 3;	// required size, default is fixed length
	r += wiresize_u64((uint64_t)m_protocol_version);
	r += wiresize_u64((uint64_t)m_timestamp);
	size_t hostscope_version_s = m_hostscope_version.size();
	r += hostscope_version_s + wiresize_u64(hostscope_version_s);
	return r;
}

size_t HostScope_MetaData::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_MetaData::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'protocol_version': id=1, encoding=0, tag=0x8
	a += varint2mem(a,e-a,0x8);	// 'protocol_version': id=1
	a += varint2mem(a,e-a,m_protocol_version);
	// 'timestamp': id=2, encoding=0, tag=0x10
	a += varint2mem(a,e-a,0x10);	// 'timestamp': id=2
	a += varint2mem(a,e-a,m_timestamp);
	// 'hostscope_version': id=3, encoding=2, tag=0x1a
	a += varint2mem(a,e-a,0x1a);	// 'hostscope_version': id=3
	size_t hostscope_version_s = m_hostscope_version.size();
	a += varint2mem(a,e-a,hostscope_version_s);
	memcpy(a,m_hostscope_version.data(),hostscope_version_s);
	a += hostscope_version_s;
	assert(a <= e);
	return a-b;
}

const std::string & HostScope_MetaData::hostscope_version() const
{ return m_hostscope_version; }

std::string *HostScope_MetaData::mutable_hostscope_version()
{ return &m_hostscope_version; }

void HostScope_MetaData::set_hostscope_version(const std::string & v)
{ m_hostscope_version = v; }

HostScope_HostInfo::HostScope_HostInfo()
: m_hostname()
, m_uptime(0)
, m_osname()
, m_osrelease()
, m_osversion()
, m_proctype()
, m_machtype()
, m_minuseruid(0)
, p_validbits(0)
{
}

void HostScope_HostInfo::clear()
{
	m_hostname.clear();
	m_uptime = 0;
	m_osname.clear();
	m_osrelease.clear();
	m_osversion.clear();
	m_proctype.clear();
	m_machtype.clear();
	m_minuseruid = 0;
	p_validbits = 0;
}

size_t HostScope_HostInfo::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0xa:	// hostname id 1, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_hostname.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x10:	// uptime id 2, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_uptime = (uint64_t)v;
			}
			break;
		case 0x13:	// uptime id 2, coding 8bit
			m_uptime = (uint64_t)*a++;
			break;
		case 0x14:	// uptime id 2, coding 16bit
			get_u16(a,(uint16_t*)&m_uptime);
			a += 2;
			break;
		case 0x15:	// uptime id 2, coding: 32bit
			get_u32(a,(uint32_t*)&m_uptime);
			a += 4;
			break;
		case 0x1a:	// osname id 3, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_osname.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x22:	// osrelease id 4, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_osrelease.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x2a:	// osversion id 5, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_osversion.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x32:	// proctype id 6, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_proctype.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x3a:	// machtype id 7, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_machtype.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x40:	// minuseruid id 8, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_minuseruid(v);
			}
			break;
		case 0x43:	// minuseruid id 8, coding 8bit
			set_minuseruid(*a++);
			break;
		case 0x44:	// minuseruid id 8, coding 16bit
			set_minuseruid(read_u16(a));
			a += 2;
			break;
		case 0x45:	// minuseruid id 8, coding: 32bit
			set_minuseruid(read_u32(a));
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_HostInfo::calcSize() const
{
	// hostname: tagsize 1
	// uptime: tagsize 1
	// osname: tagsize 1
	size_t r = 3;	// required size, default is fixed length
	size_t hostname_s = m_hostname.size();
	r += hostname_s + wiresize_u64(hostname_s);
	r += wiresize_u64((uint64_t)m_uptime);
	size_t osname_s = m_osname.size();
	r += osname_s + wiresize_u64(osname_s);
	if (has_osrelease()) {
		size_t osrelease_s = m_osrelease.size();
		r += osrelease_s + wiresize_u64(osrelease_s) + 1 /* tag(id) 0x20 */;
	}
	if (has_osversion()) {
		size_t osversion_s = m_osversion.size();
		r += osversion_s + wiresize_u64(osversion_s) + 1 /* tag(id) 0x28 */;
	}
	if (has_proctype()) {
		size_t proctype_s = m_proctype.size();
		r += proctype_s + wiresize_u64(proctype_s) + 1 /* tag(id) 0x30 */;
	}
	if (has_machtype()) {
		size_t machtype_s = m_machtype.size();
		r += machtype_s + wiresize_u64(machtype_s) + 1 /* tag(id) 0x38 */;
	}
	if (has_minuseruid()) {
		r += wiresize_u64((uint64_t)m_minuseruid) + 1 /* tag(id) 0x40 */;
	}
	return r;
}

size_t HostScope_HostInfo::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_HostInfo::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'hostname': id=1, encoding=2, tag=0xa
	a += varint2mem(a,e-a,0xa);	// 'hostname': id=1
	size_t hostname_s = m_hostname.size();
	a += varint2mem(a,e-a,hostname_s);
	memcpy(a,m_hostname.data(),hostname_s);
	a += hostname_s;
	// 'uptime': id=2, encoding=0, tag=0x10
	a += varint2mem(a,e-a,0x10);	// 'uptime': id=2
	a += varint2mem(a,e-a,m_uptime);
	// 'osname': id=3, encoding=2, tag=0x1a
	a += varint2mem(a,e-a,0x1a);	// 'osname': id=3
	size_t osname_s = m_osname.size();
	a += varint2mem(a,e-a,osname_s);
	memcpy(a,m_osname.data(),osname_s);
	a += osname_s;
	if (has_osrelease()) {
		// 'osrelease': id=4, encoding=2, tag=0x22
		a += varint2mem(a,e-a,0x22);	// 'osrelease': id=4
		size_t osrelease_s = m_osrelease.size();
		a += varint2mem(a,e-a,osrelease_s);
		memcpy(a,m_osrelease.data(),osrelease_s);
		a += osrelease_s;
	}
	if (has_osversion()) {
		// 'osversion': id=5, encoding=2, tag=0x2a
		a += varint2mem(a,e-a,0x2a);	// 'osversion': id=5
		size_t osversion_s = m_osversion.size();
		a += varint2mem(a,e-a,osversion_s);
		memcpy(a,m_osversion.data(),osversion_s);
		a += osversion_s;
	}
	if (has_proctype()) {
		// 'proctype': id=6, encoding=2, tag=0x32
		a += varint2mem(a,e-a,0x32);	// 'proctype': id=6
		size_t proctype_s = m_proctype.size();
		a += varint2mem(a,e-a,proctype_s);
		memcpy(a,m_proctype.data(),proctype_s);
		a += proctype_s;
	}
	if (has_machtype()) {
		// 'machtype': id=7, encoding=2, tag=0x3a
		a += varint2mem(a,e-a,0x3a);	// 'machtype': id=7
		size_t machtype_s = m_machtype.size();
		a += varint2mem(a,e-a,machtype_s);
		memcpy(a,m_machtype.data(),machtype_s);
		a += machtype_s;
	}
	if (has_minuseruid()) {
		// 'minuseruid': id=8, encoding=0, tag=0x40
		a += varint2mem(a,e-a,0x40);	// 'minuseruid': id=8
		a += varint2mem(a,e-a,m_minuseruid);
	}
	assert(a <= e);
	return a-b;
}

const std::string & HostScope_HostInfo::hostname() const
{ return m_hostname; }

std::string *HostScope_HostInfo::mutable_hostname()
{ return &m_hostname; }

void HostScope_HostInfo::set_hostname(const std::string & v)
{ m_hostname = v; }

const std::string & HostScope_HostInfo::osname() const
{ return m_osname; }

std::string *HostScope_HostInfo::mutable_osname()
{ return &m_osname; }

void HostScope_HostInfo::set_osname(const std::string & v)
{ m_osname = v; }

const std::string & HostScope_HostInfo::osrelease() const
{ return m_osrelease; }

std::string *HostScope_HostInfo::mutable_osrelease()
{
	return &m_osrelease;
}

void HostScope_HostInfo::set_osrelease(const std::string & v)
{
	m_osrelease = v;
}

const std::string & HostScope_HostInfo::osversion() const
{ return m_osversion; }

std::string *HostScope_HostInfo::mutable_osversion()
{
	return &m_osversion;
}

void HostScope_HostInfo::set_osversion(const std::string & v)
{
	m_osversion = v;
}

const std::string & HostScope_HostInfo::proctype() const
{ return m_proctype; }

std::string *HostScope_HostInfo::mutable_proctype()
{
	return &m_proctype;
}

void HostScope_HostInfo::set_proctype(const std::string & v)
{
	m_proctype = v;
}

const std::string & HostScope_HostInfo::machtype() const
{ return m_machtype; }

std::string *HostScope_HostInfo::mutable_machtype()
{
	return &m_machtype;
}

void HostScope_HostInfo::set_machtype(const std::string & v)
{
	m_machtype = v;
}

uint32_t *HostScope_HostInfo::mutable_minuseruid()
{
	if (0 == (p_validbits & ((uint8_t)1U << 0))) {
		m_minuseruid = 0;
		p_validbits |= ((uint8_t)1U << 0);
	}
	return &m_minuseruid;
}

void HostScope_HostInfo::set_minuseruid(uint32_t  v)
{
	m_minuseruid = v;
	p_validbits |= ((uint8_t)1U << 0);
}

HostScope_LoadAvg::HostScope_LoadAvg()
: m_loadav1m(0)
, m_loadav5m(0)
, m_loadav15m(0)
{
}

void HostScope_LoadAvg::clear()
{
	m_loadav1m = 0;
	m_loadav5m = 0;
	m_loadav15m = 0;
}

size_t HostScope_LoadAvg::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0x8:	// loadav1m id 1, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_loadav1m = (uint32_t)v;
			}
			break;
		case 0xb:	// loadav1m id 1, coding 8bit
			m_loadav1m = (uint32_t)*a++;
			break;
		case 0xc:	// loadav1m id 1, coding 16bit
			get_u16(a,(uint16_t*)&m_loadav1m);
			a += 2;
			break;
		case 0xd:	// loadav1m id 1, coding: 32bit
			get_u32(a,(uint32_t*)&m_loadav1m);
			a += 4;
			break;
		case 0x10:	// loadav5m id 2, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_loadav5m = (uint32_t)v;
			}
			break;
		case 0x13:	// loadav5m id 2, coding 8bit
			m_loadav5m = (uint32_t)*a++;
			break;
		case 0x14:	// loadav5m id 2, coding 16bit
			get_u16(a,(uint16_t*)&m_loadav5m);
			a += 2;
			break;
		case 0x15:	// loadav5m id 2, coding: 32bit
			get_u32(a,(uint32_t*)&m_loadav5m);
			a += 4;
			break;
		case 0x18:	// loadav15m id 3, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_loadav15m = (uint32_t)v;
			}
			break;
		case 0x1b:	// loadav15m id 3, coding 8bit
			m_loadav15m = (uint32_t)*a++;
			break;
		case 0x1c:	// loadav15m id 3, coding 16bit
			get_u16(a,(uint16_t*)&m_loadav15m);
			a += 2;
			break;
		case 0x1d:	// loadav15m id 3, coding: 32bit
			get_u32(a,(uint32_t*)&m_loadav15m);
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_LoadAvg::calcSize() const
{
	// loadav1m: tagsize 1
	// loadav5m: tagsize 1
	// loadav15m: tagsize 1
	size_t r = 3;	// required size, default is fixed length
	r += wiresize_u64((uint64_t)m_loadav1m);
	r += wiresize_u64((uint64_t)m_loadav5m);
	r += wiresize_u64((uint64_t)m_loadav15m);
	return r;
}

size_t HostScope_LoadAvg::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_LoadAvg::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'loadav1m': id=1, encoding=0, tag=0x8
	a += varint2mem(a,e-a,0x8);	// 'loadav1m': id=1
	a += varint2mem(a,e-a,m_loadav1m);
	// 'loadav5m': id=2, encoding=0, tag=0x10
	a += varint2mem(a,e-a,0x10);	// 'loadav5m': id=2
	a += varint2mem(a,e-a,m_loadav5m);
	// 'loadav15m': id=3, encoding=0, tag=0x18
	a += varint2mem(a,e-a,0x18);	// 'loadav15m': id=3
	a += varint2mem(a,e-a,m_loadav15m);
	assert(a <= e);
	return a-b;
}

HostScope_Memory::HostScope_Memory()
: m_physical(0)
, m_free(0)
, m_swapsize(0)
, m_pagedout(0)
, m_locked(0)
, p_validbits(0)
{
}

void HostScope_Memory::clear()
{
	m_physical = 0;
	m_free = 0;
	m_swapsize = 0;
	m_pagedout = 0;
	m_locked = 0;
	p_validbits = 0;
}

size_t HostScope_Memory::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0x8:	// physical id 1, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_physical(v);
			}
			break;
		case 0xb:	// physical id 1, coding 8bit
			set_physical(*a++);
			break;
		case 0xc:	// physical id 1, coding 16bit
			set_physical(read_u16(a));
			a += 2;
			break;
		case 0xd:	// physical id 1, coding: 32bit
			set_physical(read_u32(a));
			a += 4;
			break;
		case 0x10:	// free id 2, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_free(v);
			}
			break;
		case 0x13:	// free id 2, coding 8bit
			set_free(*a++);
			break;
		case 0x14:	// free id 2, coding 16bit
			set_free(read_u16(a));
			a += 2;
			break;
		case 0x15:	// free id 2, coding: 32bit
			set_free(read_u32(a));
			a += 4;
			break;
		case 0x18:	// swapsize id 3, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_swapsize(v);
			}
			break;
		case 0x1b:	// swapsize id 3, coding 8bit
			set_swapsize(*a++);
			break;
		case 0x1c:	// swapsize id 3, coding 16bit
			set_swapsize(read_u16(a));
			a += 2;
			break;
		case 0x1d:	// swapsize id 3, coding: 32bit
			set_swapsize(read_u32(a));
			a += 4;
			break;
		case 0x20:	// pagedout id 4, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_pagedout(v);
			}
			break;
		case 0x23:	// pagedout id 4, coding 8bit
			set_pagedout(*a++);
			break;
		case 0x24:	// pagedout id 4, coding 16bit
			set_pagedout(read_u16(a));
			a += 2;
			break;
		case 0x25:	// pagedout id 4, coding: 32bit
			set_pagedout(read_u32(a));
			a += 4;
			break;
		case 0x28:	// locked id 5, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_locked(v);
			}
			break;
		case 0x2b:	// locked id 5, coding 8bit
			set_locked(*a++);
			break;
		case 0x2c:	// locked id 5, coding 16bit
			set_locked(read_u16(a));
			a += 2;
			break;
		case 0x2d:	// locked id 5, coding: 32bit
			set_locked(read_u32(a));
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_Memory::calcSize() const
{
	size_t r = 0;	// required size, default is fixed length
	if (has_physical()) {
		r += wiresize_u64((uint64_t)m_physical) + 1 /* tag(id) 0x8 */;
	}
	if (has_free()) {
		r += wiresize_u64((uint64_t)m_free) + 1 /* tag(id) 0x10 */;
	}
	if (has_swapsize()) {
		r += wiresize_u64((uint64_t)m_swapsize) + 1 /* tag(id) 0x18 */;
	}
	if (has_pagedout()) {
		r += wiresize_u64((uint64_t)m_pagedout) + 1 /* tag(id) 0x20 */;
	}
	if (has_locked()) {
		r += wiresize_u64((uint64_t)m_locked) + 1 /* tag(id) 0x28 */;
	}
	return r;
}

size_t HostScope_Memory::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_Memory::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	if (has_physical()) {
		// 'physical': id=1, encoding=0, tag=0x8
		a += varint2mem(a,e-a,0x8);	// 'physical': id=1
		a += varint2mem(a,e-a,m_physical);
	}
	if (has_free()) {
		// 'free': id=2, encoding=0, tag=0x10
		a += varint2mem(a,e-a,0x10);	// 'free': id=2
		a += varint2mem(a,e-a,m_free);
	}
	if (has_swapsize()) {
		// 'swapsize': id=3, encoding=0, tag=0x18
		a += varint2mem(a,e-a,0x18);	// 'swapsize': id=3
		a += varint2mem(a,e-a,m_swapsize);
	}
	if (has_pagedout()) {
		// 'pagedout': id=4, encoding=0, tag=0x20
		a += varint2mem(a,e-a,0x20);	// 'pagedout': id=4
		a += varint2mem(a,e-a,m_pagedout);
	}
	if (has_locked()) {
		// 'locked': id=5, encoding=0, tag=0x28
		a += varint2mem(a,e-a,0x28);	// 'locked': id=5
		a += varint2mem(a,e-a,m_locked);
	}
	assert(a <= e);
	return a-b;
}

uint64_t *HostScope_Memory::mutable_physical()
{
	if (0 == (p_validbits & ((uint8_t)1U << 0))) {
		m_physical = 0;
		p_validbits |= ((uint8_t)1U << 0);
	}
	return &m_physical;
}

void HostScope_Memory::set_physical(uint64_t  v)
{
	m_physical = v;
	p_validbits |= ((uint8_t)1U << 0);
}

uint64_t *HostScope_Memory::mutable_free()
{
	if (0 == (p_validbits & ((uint8_t)1U << 1))) {
		m_free = 0;
		p_validbits |= ((uint8_t)1U << 1);
	}
	return &m_free;
}

void HostScope_Memory::set_free(uint64_t  v)
{
	m_free = v;
	p_validbits |= ((uint8_t)1U << 1);
}

uint64_t *HostScope_Memory::mutable_swapsize()
{
	if (0 == (p_validbits & ((uint8_t)1U << 2))) {
		m_swapsize = 0;
		p_validbits |= ((uint8_t)1U << 2);
	}
	return &m_swapsize;
}

void HostScope_Memory::set_swapsize(uint64_t  v)
{
	m_swapsize = v;
	p_validbits |= ((uint8_t)1U << 2);
}

uint64_t *HostScope_Memory::mutable_pagedout()
{
	if (0 == (p_validbits & ((uint8_t)1U << 3))) {
		m_pagedout = 0;
		p_validbits |= ((uint8_t)1U << 3);
	}
	return &m_pagedout;
}

void HostScope_Memory::set_pagedout(uint64_t  v)
{
	m_pagedout = v;
	p_validbits |= ((uint8_t)1U << 3);
}

uint64_t *HostScope_Memory::mutable_locked()
{
	if (0 == (p_validbits & ((uint8_t)1U << 4))) {
		m_locked = 0;
		p_validbits |= ((uint8_t)1U << 4);
	}
	return &m_locked;
}

void HostScope_Memory::set_locked(uint64_t  v)
{
	m_locked = v;
	p_validbits |= ((uint8_t)1U << 4);
}

HostScope_PowerSupply::HostScope_PowerSupply()
: m_name()
, m_state()
, m_capacity(0)
, p_validbits(0)
{
}

void HostScope_PowerSupply::clear()
{
	m_name.clear();
	m_state.clear();
	m_capacity = 0;
	p_validbits = 0;
}

size_t HostScope_PowerSupply::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0xa:	// name id 1, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_name.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x12:	// state id 2, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_state.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x18:	// capacity id 3, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_capacity(v);
			}
			break;
		case 0x1b:	// capacity id 3, coding 8bit
			set_capacity(*a++);
			break;
		case 0x1c:	// capacity id 3, coding 16bit
			set_capacity(read_u16(a));
			a += 2;
			break;
		case 0x1d:	// capacity id 3, coding: 32bit
			set_capacity(read_u32(a));
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_PowerSupply::calcSize() const
{
	// name: tagsize 1
	// state: tagsize 1
	size_t r = 2;	// required size, default is fixed length
	size_t name_s = m_name.size();
	r += name_s + wiresize_u64(name_s);
	size_t state_s = m_state.size();
	r += state_s + wiresize_u64(state_s);
	if (has_capacity()) {
		r += wiresize_u64((uint64_t)m_capacity) + 1 /* tag(id) 0x18 */;
	}
	return r;
}

size_t HostScope_PowerSupply::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_PowerSupply::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'name': id=1, encoding=2, tag=0xa
	a += varint2mem(a,e-a,0xa);	// 'name': id=1
	size_t name_s = m_name.size();
	a += varint2mem(a,e-a,name_s);
	memcpy(a,m_name.data(),name_s);
	a += name_s;
	// 'state': id=2, encoding=2, tag=0x12
	a += varint2mem(a,e-a,0x12);	// 'state': id=2
	size_t state_s = m_state.size();
	a += varint2mem(a,e-a,state_s);
	memcpy(a,m_state.data(),state_s);
	a += state_s;
	if (has_capacity()) {
		// 'capacity': id=3, encoding=0, tag=0x18
		a += varint2mem(a,e-a,0x18);	// 'capacity': id=3
		a += varint2mem(a,e-a,m_capacity);
	}
	assert(a <= e);
	return a-b;
}

const std::string & HostScope_PowerSupply::name() const
{ return m_name; }

std::string *HostScope_PowerSupply::mutable_name()
{ return &m_name; }

void HostScope_PowerSupply::set_name(const std::string & v)
{ m_name = v; }

const std::string & HostScope_PowerSupply::state() const
{ return m_state; }

std::string *HostScope_PowerSupply::mutable_state()
{ return &m_state; }

void HostScope_PowerSupply::set_state(const std::string & v)
{ m_state = v; }

uint32_t *HostScope_PowerSupply::mutable_capacity()
{
	if (0 == (p_validbits & ((uint8_t)1U << 0))) {
		m_capacity = 0;
		p_validbits |= ((uint8_t)1U << 0);
	}
	return &m_capacity;
}

void HostScope_PowerSupply::set_capacity(uint32_t  v)
{
	m_capacity = v;
	p_validbits |= ((uint8_t)1U << 0);
}

HostScope_LinuxInfo::HostScope_LinuxInfo()
: m_forks(0)
, m_ctxtsw(0)
, m_intrs(0)
, m_sirqs(0)
{
}

void HostScope_LinuxInfo::clear()
{
	m_forks = 0;
	m_ctxtsw = 0;
	m_intrs = 0;
	m_sirqs = 0;
}

size_t HostScope_LinuxInfo::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0x8:	// forks id 1, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_forks = (uint32_t)v;
			}
			break;
		case 0xb:	// forks id 1, coding 8bit
			m_forks = (uint32_t)*a++;
			break;
		case 0xc:	// forks id 1, coding 16bit
			get_u16(a,(uint16_t*)&m_forks);
			a += 2;
			break;
		case 0xd:	// forks id 1, coding: 32bit
			get_u32(a,(uint32_t*)&m_forks);
			a += 4;
			break;
		case 0x10:	// ctxtsw id 2, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_ctxtsw = (uint32_t)v;
			}
			break;
		case 0x13:	// ctxtsw id 2, coding 8bit
			m_ctxtsw = (uint32_t)*a++;
			break;
		case 0x14:	// ctxtsw id 2, coding 16bit
			get_u16(a,(uint16_t*)&m_ctxtsw);
			a += 2;
			break;
		case 0x15:	// ctxtsw id 2, coding: 32bit
			get_u32(a,(uint32_t*)&m_ctxtsw);
			a += 4;
			break;
		case 0x18:	// intrs id 3, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_intrs = (uint32_t)v;
			}
			break;
		case 0x1b:	// intrs id 3, coding 8bit
			m_intrs = (uint32_t)*a++;
			break;
		case 0x1c:	// intrs id 3, coding 16bit
			get_u16(a,(uint16_t*)&m_intrs);
			a += 2;
			break;
		case 0x1d:	// intrs id 3, coding: 32bit
			get_u32(a,(uint32_t*)&m_intrs);
			a += 4;
			break;
		case 0x20:	// sirqs id 4, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_sirqs = (uint32_t)v;
			}
			break;
		case 0x23:	// sirqs id 4, coding 8bit
			m_sirqs = (uint32_t)*a++;
			break;
		case 0x24:	// sirqs id 4, coding 16bit
			get_u16(a,(uint16_t*)&m_sirqs);
			a += 2;
			break;
		case 0x25:	// sirqs id 4, coding: 32bit
			get_u32(a,(uint32_t*)&m_sirqs);
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_LinuxInfo::calcSize() const
{
	// forks: tagsize 1
	// ctxtsw: tagsize 1
	// intrs: tagsize 1
	// sirqs: tagsize 1
	size_t r = 4;	// required size, default is fixed length
	r += wiresize_u64((uint64_t)m_forks);
	r += wiresize_u64((uint64_t)m_ctxtsw);
	r += wiresize_u64((uint64_t)m_intrs);
	r += wiresize_u64((uint64_t)m_sirqs);
	return r;
}

size_t HostScope_LinuxInfo::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_LinuxInfo::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'forks': id=1, encoding=0, tag=0x8
	a += varint2mem(a,e-a,0x8);	// 'forks': id=1
	a += varint2mem(a,e-a,m_forks);
	// 'ctxtsw': id=2, encoding=0, tag=0x10
	a += varint2mem(a,e-a,0x10);	// 'ctxtsw': id=2
	a += varint2mem(a,e-a,m_ctxtsw);
	// 'intrs': id=3, encoding=0, tag=0x18
	a += varint2mem(a,e-a,0x18);	// 'intrs': id=3
	a += varint2mem(a,e-a,m_intrs);
	// 'sirqs': id=4, encoding=0, tag=0x20
	a += varint2mem(a,e-a,0x20);	// 'sirqs': id=4
	a += varint2mem(a,e-a,m_sirqs);
	assert(a <= e);
	return a-b;
}

HostScope_LinuxVmstat::HostScope_LinuxVmstat()
: m_nr_free_pages(0)
, m_nr_mlock(0)
, m_nr_anon_pages(0)
, m_nr_file_pages(0)
, m_nr_kernel_stack(0)
, m_nr_shmem(0)
, m_pgpgin(0)
, m_pgpgout(0)
, m_pgfree(0)
, m_pgfault(0)
, m_pgmajfault(0)
, p_validbits(0)
{
}

void HostScope_LinuxVmstat::clear()
{
	m_nr_free_pages = 0;
	m_nr_mlock = 0;
	m_nr_anon_pages = 0;
	m_nr_file_pages = 0;
	m_nr_kernel_stack = 0;
	m_nr_shmem = 0;
	m_pgpgin = 0;
	m_pgpgout = 0;
	m_pgfree = 0;
	m_pgfault = 0;
	m_pgmajfault = 0;
	p_validbits = 0;
}

size_t HostScope_LinuxVmstat::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0x8:	// nr_free_pages id 1, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nr_free_pages(v);
			}
			break;
		case 0xb:	// nr_free_pages id 1, coding 8bit
			set_nr_free_pages(*a++);
			break;
		case 0xc:	// nr_free_pages id 1, coding 16bit
			set_nr_free_pages(read_u16(a));
			a += 2;
			break;
		case 0xd:	// nr_free_pages id 1, coding: 32bit
			set_nr_free_pages(read_u32(a));
			a += 4;
			break;
		case 0x40:	// nr_mlock id 8, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nr_mlock(v);
			}
			break;
		case 0x43:	// nr_mlock id 8, coding 8bit
			set_nr_mlock(*a++);
			break;
		case 0x44:	// nr_mlock id 8, coding 16bit
			set_nr_mlock(read_u16(a));
			a += 2;
			break;
		case 0x45:	// nr_mlock id 8, coding: 32bit
			set_nr_mlock(read_u32(a));
			a += 4;
			break;
		case 0x48:	// nr_anon_pages id 9, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nr_anon_pages(v);
			}
			break;
		case 0x4b:	// nr_anon_pages id 9, coding 8bit
			set_nr_anon_pages(*a++);
			break;
		case 0x4c:	// nr_anon_pages id 9, coding 16bit
			set_nr_anon_pages(read_u16(a));
			a += 2;
			break;
		case 0x4d:	// nr_anon_pages id 9, coding: 32bit
			set_nr_anon_pages(read_u32(a));
			a += 4;
			break;
		case 0x58:	// nr_file_pages id 11, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nr_file_pages(v);
			}
			break;
		case 0x5b:	// nr_file_pages id 11, coding 8bit
			set_nr_file_pages(*a++);
			break;
		case 0x5c:	// nr_file_pages id 11, coding 16bit
			set_nr_file_pages(read_u16(a));
			a += 2;
			break;
		case 0x5d:	// nr_file_pages id 11, coding: 32bit
			set_nr_file_pages(read_u32(a));
			a += 4;
			break;
		case 0x88:	// nr_kernel_stack id 17, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nr_kernel_stack(v);
			}
			break;
		case 0x8b:	// nr_kernel_stack id 17, coding 8bit
			set_nr_kernel_stack(*a++);
			break;
		case 0x8c:	// nr_kernel_stack id 17, coding 16bit
			set_nr_kernel_stack(read_u16(a));
			a += 2;
			break;
		case 0x8d:	// nr_kernel_stack id 17, coding: 32bit
			set_nr_kernel_stack(read_u32(a));
			a += 4;
			break;
		case 0xc8:	// nr_shmem id 25, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nr_shmem(v);
			}
			break;
		case 0xcb:	// nr_shmem id 25, coding 8bit
			set_nr_shmem(*a++);
			break;
		case 0xcc:	// nr_shmem id 25, coding 16bit
			set_nr_shmem(read_u16(a));
			a += 2;
			break;
		case 0xcd:	// nr_shmem id 25, coding: 32bit
			set_nr_shmem(read_u32(a));
			a += 4;
			break;
		case 0x130:	// pgpgin id 38, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_pgpgin(v);
			}
			break;
		case 0x133:	// pgpgin id 38, coding 8bit
			set_pgpgin(*a++);
			break;
		case 0x134:	// pgpgin id 38, coding 16bit
			set_pgpgin(read_u16(a));
			a += 2;
			break;
		case 0x135:	// pgpgin id 38, coding: 32bit
			set_pgpgin(read_u32(a));
			a += 4;
			break;
		case 0x138:	// pgpgout id 39, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_pgpgout(v);
			}
			break;
		case 0x13b:	// pgpgout id 39, coding 8bit
			set_pgpgout(*a++);
			break;
		case 0x13c:	// pgpgout id 39, coding 16bit
			set_pgpgout(read_u16(a));
			a += 2;
			break;
		case 0x13d:	// pgpgout id 39, coding: 32bit
			set_pgpgout(read_u32(a));
			a += 4;
			break;
		case 0x170:	// pgfree id 46, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_pgfree(v);
			}
			break;
		case 0x173:	// pgfree id 46, coding 8bit
			set_pgfree(*a++);
			break;
		case 0x174:	// pgfree id 46, coding 16bit
			set_pgfree(read_u16(a));
			a += 2;
			break;
		case 0x175:	// pgfree id 46, coding: 32bit
			set_pgfree(read_u32(a));
			a += 4;
			break;
		case 0x188:	// pgfault id 49, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_pgfault(v);
			}
			break;
		case 0x18b:	// pgfault id 49, coding 8bit
			set_pgfault(*a++);
			break;
		case 0x18c:	// pgfault id 49, coding 16bit
			set_pgfault(read_u16(a));
			a += 2;
			break;
		case 0x18d:	// pgfault id 49, coding: 32bit
			set_pgfault(read_u32(a));
			a += 4;
			break;
		case 0x190:	// pgmajfault id 50, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_pgmajfault(v);
			}
			break;
		case 0x193:	// pgmajfault id 50, coding 8bit
			set_pgmajfault(*a++);
			break;
		case 0x194:	// pgmajfault id 50, coding 16bit
			set_pgmajfault(read_u16(a));
			a += 2;
			break;
		case 0x195:	// pgmajfault id 50, coding: 32bit
			set_pgmajfault(read_u32(a));
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_LinuxVmstat::calcSize() const
{
	size_t r = 0;	// required size, default is fixed length
	if (has_nr_free_pages()) {
		r += wiresize_u64((uint64_t)m_nr_free_pages) + 1 /* tag(id) 0x8 */;
	}
	if (has_nr_mlock()) {
		r += wiresize_u64((uint64_t)m_nr_mlock) + 1 /* tag(id) 0x40 */;
	}
	if (has_nr_anon_pages()) {
		r += wiresize_u64((uint64_t)m_nr_anon_pages) + 1 /* tag(id) 0x48 */;
	}
	if (has_nr_file_pages()) {
		r += wiresize_u64((uint64_t)m_nr_file_pages) + 1 /* tag(id) 0x58 */;
	}
	if (has_nr_kernel_stack()) {
		r += wiresize_u64((uint64_t)m_nr_kernel_stack) + 2 /* tag(id) 0x88 */;
	}
	if (has_nr_shmem()) {
		r += wiresize_u64((uint64_t)m_nr_shmem) + 2 /* tag(id) 0xc8 */;
	}
	if (has_pgpgin()) {
		r += wiresize_u64((uint64_t)m_pgpgin) + 2 /* tag(id) 0x130 */;
	}
	if (has_pgpgout()) {
		r += wiresize_u64((uint64_t)m_pgpgout) + 2 /* tag(id) 0x138 */;
	}
	if (has_pgfree()) {
		r += wiresize_u64((uint64_t)m_pgfree) + 2 /* tag(id) 0x170 */;
	}
	if (has_pgfault()) {
		r += wiresize_u64((uint64_t)m_pgfault) + 2 /* tag(id) 0x188 */;
	}
	if (has_pgmajfault()) {
		r += wiresize_u64((uint64_t)m_pgmajfault) + 2 /* tag(id) 0x190 */;
	}
	return r;
}

size_t HostScope_LinuxVmstat::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_LinuxVmstat::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	if (has_nr_free_pages()) {
		// 'nr_free_pages': id=1, encoding=0, tag=0x8
		a += varint2mem(a,e-a,0x8);	// 'nr_free_pages': id=1
		a += varint2mem(a,e-a,m_nr_free_pages);
	}
	if (has_nr_mlock()) {
		// 'nr_mlock': id=8, encoding=0, tag=0x40
		a += varint2mem(a,e-a,0x40);	// 'nr_mlock': id=8
		a += varint2mem(a,e-a,m_nr_mlock);
	}
	if (has_nr_anon_pages()) {
		// 'nr_anon_pages': id=9, encoding=0, tag=0x48
		a += varint2mem(a,e-a,0x48);	// 'nr_anon_pages': id=9
		a += varint2mem(a,e-a,m_nr_anon_pages);
	}
	if (has_nr_file_pages()) {
		// 'nr_file_pages': id=11, encoding=0, tag=0x58
		a += varint2mem(a,e-a,0x58);	// 'nr_file_pages': id=11
		a += varint2mem(a,e-a,m_nr_file_pages);
	}
	if (has_nr_kernel_stack()) {
		// 'nr_kernel_stack': id=17, encoding=0, tag=0x88
		a += varint2mem(a,e-a,0x88);	// 'nr_kernel_stack': id=17
		a += varint2mem(a,e-a,m_nr_kernel_stack);
	}
	if (has_nr_shmem()) {
		// 'nr_shmem': id=25, encoding=0, tag=0xc8
		a += varint2mem(a,e-a,0xc8);	// 'nr_shmem': id=25
		a += varint2mem(a,e-a,m_nr_shmem);
	}
	if (has_pgpgin()) {
		// 'pgpgin': id=38, encoding=0, tag=0x130
		a += varint2mem(a,e-a,0x130);	// 'pgpgin': id=38
		a += varint2mem(a,e-a,m_pgpgin);
	}
	if (has_pgpgout()) {
		// 'pgpgout': id=39, encoding=0, tag=0x138
		a += varint2mem(a,e-a,0x138);	// 'pgpgout': id=39
		a += varint2mem(a,e-a,m_pgpgout);
	}
	if (has_pgfree()) {
		// 'pgfree': id=46, encoding=0, tag=0x170
		a += varint2mem(a,e-a,0x170);	// 'pgfree': id=46
		a += varint2mem(a,e-a,m_pgfree);
	}
	if (has_pgfault()) {
		// 'pgfault': id=49, encoding=0, tag=0x188
		a += varint2mem(a,e-a,0x188);	// 'pgfault': id=49
		a += varint2mem(a,e-a,m_pgfault);
	}
	if (has_pgmajfault()) {
		// 'pgmajfault': id=50, encoding=0, tag=0x190
		a += varint2mem(a,e-a,0x190);	// 'pgmajfault': id=50
		a += varint2mem(a,e-a,m_pgmajfault);
	}
	assert(a <= e);
	return a-b;
}

uint64_t *HostScope_LinuxVmstat::mutable_nr_free_pages()
{
	if (0 == (p_validbits & ((uint16_t)1U << 0))) {
		m_nr_free_pages = 0;
		p_validbits |= ((uint16_t)1U << 0);
	}
	return &m_nr_free_pages;
}

void HostScope_LinuxVmstat::set_nr_free_pages(uint64_t  v)
{
	m_nr_free_pages = v;
	p_validbits |= ((uint16_t)1U << 0);
}

uint64_t *HostScope_LinuxVmstat::mutable_nr_mlock()
{
	if (0 == (p_validbits & ((uint16_t)1U << 1))) {
		m_nr_mlock = 0;
		p_validbits |= ((uint16_t)1U << 1);
	}
	return &m_nr_mlock;
}

void HostScope_LinuxVmstat::set_nr_mlock(uint64_t  v)
{
	m_nr_mlock = v;
	p_validbits |= ((uint16_t)1U << 1);
}

uint64_t *HostScope_LinuxVmstat::mutable_nr_anon_pages()
{
	if (0 == (p_validbits & ((uint16_t)1U << 2))) {
		m_nr_anon_pages = 0;
		p_validbits |= ((uint16_t)1U << 2);
	}
	return &m_nr_anon_pages;
}

void HostScope_LinuxVmstat::set_nr_anon_pages(uint64_t  v)
{
	m_nr_anon_pages = v;
	p_validbits |= ((uint16_t)1U << 2);
}

uint64_t *HostScope_LinuxVmstat::mutable_nr_file_pages()
{
	if (0 == (p_validbits & ((uint16_t)1U << 3))) {
		m_nr_file_pages = 0;
		p_validbits |= ((uint16_t)1U << 3);
	}
	return &m_nr_file_pages;
}

void HostScope_LinuxVmstat::set_nr_file_pages(uint64_t  v)
{
	m_nr_file_pages = v;
	p_validbits |= ((uint16_t)1U << 3);
}

uint64_t *HostScope_LinuxVmstat::mutable_nr_kernel_stack()
{
	if (0 == (p_validbits & ((uint16_t)1U << 4))) {
		m_nr_kernel_stack = 0;
		p_validbits |= ((uint16_t)1U << 4);
	}
	return &m_nr_kernel_stack;
}

void HostScope_LinuxVmstat::set_nr_kernel_stack(uint64_t  v)
{
	m_nr_kernel_stack = v;
	p_validbits |= ((uint16_t)1U << 4);
}

uint64_t *HostScope_LinuxVmstat::mutable_nr_shmem()
{
	if (0 == (p_validbits & ((uint16_t)1U << 5))) {
		m_nr_shmem = 0;
		p_validbits |= ((uint16_t)1U << 5);
	}
	return &m_nr_shmem;
}

void HostScope_LinuxVmstat::set_nr_shmem(uint64_t  v)
{
	m_nr_shmem = v;
	p_validbits |= ((uint16_t)1U << 5);
}

uint64_t *HostScope_LinuxVmstat::mutable_pgpgin()
{
	if (0 == (p_validbits & ((uint16_t)1U << 6))) {
		m_pgpgin = 0;
		p_validbits |= ((uint16_t)1U << 6);
	}
	return &m_pgpgin;
}

void HostScope_LinuxVmstat::set_pgpgin(uint64_t  v)
{
	m_pgpgin = v;
	p_validbits |= ((uint16_t)1U << 6);
}

uint64_t *HostScope_LinuxVmstat::mutable_pgpgout()
{
	if (0 == (p_validbits & ((uint16_t)1U << 7))) {
		m_pgpgout = 0;
		p_validbits |= ((uint16_t)1U << 7);
	}
	return &m_pgpgout;
}

void HostScope_LinuxVmstat::set_pgpgout(uint64_t  v)
{
	m_pgpgout = v;
	p_validbits |= ((uint16_t)1U << 7);
}

uint64_t *HostScope_LinuxVmstat::mutable_pgfree()
{
	if (0 == (p_validbits & ((uint16_t)1U << 8))) {
		m_pgfree = 0;
		p_validbits |= ((uint16_t)1U << 8);
	}
	return &m_pgfree;
}

void HostScope_LinuxVmstat::set_pgfree(uint64_t  v)
{
	m_pgfree = v;
	p_validbits |= ((uint16_t)1U << 8);
}

uint64_t *HostScope_LinuxVmstat::mutable_pgfault()
{
	if (0 == (p_validbits & ((uint16_t)1U << 9))) {
		m_pgfault = 0;
		p_validbits |= ((uint16_t)1U << 9);
	}
	return &m_pgfault;
}

void HostScope_LinuxVmstat::set_pgfault(uint64_t  v)
{
	m_pgfault = v;
	p_validbits |= ((uint16_t)1U << 9);
}

uint64_t *HostScope_LinuxVmstat::mutable_pgmajfault()
{
	if (0 == (p_validbits & ((uint16_t)1U << 10))) {
		m_pgmajfault = 0;
		p_validbits |= ((uint16_t)1U << 10);
	}
	return &m_pgmajfault;
}

void HostScope_LinuxVmstat::set_pgmajfault(uint64_t  v)
{
	m_pgmajfault = v;
	p_validbits |= ((uint16_t)1U << 10);
}

HostScope_LinuxCPU::HostScope_LinuxCPU()
: m_id(0)
, m_user(0)
, m_nice(0)
, m_system(0)
, m_idle(0)
, m_iowait(0)
, m_irq(0)
, m_vhost(0)
, m_currtemp(0)
, m_crittemp(0)
, m_currmhz(0)
, p_validbits(0)
{
}

void HostScope_LinuxCPU::clear()
{
	m_id = 0;
	m_user = 0;
	m_nice = 0;
	m_system = 0;
	m_idle = 0;
	m_iowait = 0;
	m_irq = 0;
	m_vhost = 0;
	m_currtemp = 0;
	m_crittemp = 0;
	m_currmhz = 0;
	p_validbits = 0;
}

size_t HostScope_LinuxCPU::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0x8:	// id id 1, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_id = (uint32_t)v;
			}
			break;
		case 0xb:	// id id 1, coding 8bit
			m_id = (uint32_t)*a++;
			break;
		case 0xc:	// id id 1, coding 16bit
			get_u16(a,(uint16_t*)&m_id);
			a += 2;
			break;
		case 0xd:	// id id 1, coding: 32bit
			get_u32(a,(uint32_t*)&m_id);
			a += 4;
			break;
		case 0x10:	// user id 2, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_user = (uint32_t)v;
			}
			break;
		case 0x13:	// user id 2, coding 8bit
			m_user = (uint32_t)*a++;
			break;
		case 0x14:	// user id 2, coding 16bit
			get_u16(a,(uint16_t*)&m_user);
			a += 2;
			break;
		case 0x15:	// user id 2, coding: 32bit
			get_u32(a,(uint32_t*)&m_user);
			a += 4;
			break;
		case 0x18:	// nice id 3, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_nice = (uint32_t)v;
			}
			break;
		case 0x1b:	// nice id 3, coding 8bit
			m_nice = (uint32_t)*a++;
			break;
		case 0x1c:	// nice id 3, coding 16bit
			get_u16(a,(uint16_t*)&m_nice);
			a += 2;
			break;
		case 0x1d:	// nice id 3, coding: 32bit
			get_u32(a,(uint32_t*)&m_nice);
			a += 4;
			break;
		case 0x20:	// system id 4, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_system = (uint32_t)v;
			}
			break;
		case 0x23:	// system id 4, coding 8bit
			m_system = (uint32_t)*a++;
			break;
		case 0x24:	// system id 4, coding 16bit
			get_u16(a,(uint16_t*)&m_system);
			a += 2;
			break;
		case 0x25:	// system id 4, coding: 32bit
			get_u32(a,(uint32_t*)&m_system);
			a += 4;
			break;
		case 0x28:	// idle id 5, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_idle = (uint32_t)v;
			}
			break;
		case 0x2b:	// idle id 5, coding 8bit
			m_idle = (uint32_t)*a++;
			break;
		case 0x2c:	// idle id 5, coding 16bit
			get_u16(a,(uint16_t*)&m_idle);
			a += 2;
			break;
		case 0x2d:	// idle id 5, coding: 32bit
			get_u32(a,(uint32_t*)&m_idle);
			a += 4;
			break;
		case 0x30:	// iowait id 6, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_iowait = (uint32_t)v;
			}
			break;
		case 0x33:	// iowait id 6, coding 8bit
			m_iowait = (uint32_t)*a++;
			break;
		case 0x34:	// iowait id 6, coding 16bit
			get_u16(a,(uint16_t*)&m_iowait);
			a += 2;
			break;
		case 0x35:	// iowait id 6, coding: 32bit
			get_u32(a,(uint32_t*)&m_iowait);
			a += 4;
			break;
		case 0x38:	// irq id 7, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_irq(v);
			}
			break;
		case 0x3b:	// irq id 7, coding 8bit
			set_irq(*a++);
			break;
		case 0x3c:	// irq id 7, coding 16bit
			set_irq(read_u16(a));
			a += 2;
			break;
		case 0x3d:	// irq id 7, coding: 32bit
			set_irq(read_u32(a));
			a += 4;
			break;
		case 0x40:	// vhost id 8, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_vhost(v);
			}
			break;
		case 0x43:	// vhost id 8, coding 8bit
			set_vhost(*a++);
			break;
		case 0x44:	// vhost id 8, coding 16bit
			set_vhost(read_u16(a));
			a += 2;
			break;
		case 0x45:	// vhost id 8, coding: 32bit
			set_vhost(read_u32(a));
			a += 4;
			break;
		case 0x48:	// currtemp id 9, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_currtemp(v);
			}
			break;
		case 0x4b:	// currtemp id 9, coding 8bit
			set_currtemp(*a++);
			break;
		case 0x4c:	// currtemp id 9, coding 16bit
			set_currtemp(read_u16(a));
			a += 2;
			break;
		case 0x4d:	// currtemp id 9, coding: 32bit
			set_currtemp(read_u32(a));
			a += 4;
			break;
		case 0x50:	// crittemp id 10, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_crittemp(v);
			}
			break;
		case 0x53:	// crittemp id 10, coding 8bit
			set_crittemp(*a++);
			break;
		case 0x54:	// crittemp id 10, coding 16bit
			set_crittemp(read_u16(a));
			a += 2;
			break;
		case 0x55:	// crittemp id 10, coding: 32bit
			set_crittemp(read_u32(a));
			a += 4;
			break;
		case 0x58:	// currmhz id 11, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_currmhz(v);
			}
			break;
		case 0x5b:	// currmhz id 11, coding 8bit
			set_currmhz(*a++);
			break;
		case 0x5c:	// currmhz id 11, coding 16bit
			set_currmhz(read_u16(a));
			a += 2;
			break;
		case 0x5d:	// currmhz id 11, coding: 32bit
			set_currmhz(read_u32(a));
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_LinuxCPU::calcSize() const
{
	// id: tagsize 1
	// user: tagsize 1
	// nice: tagsize 1
	// system: tagsize 1
	// idle: tagsize 1
	// iowait: tagsize 1
	size_t r = 6;	// required size, default is fixed length
	r += wiresize_u64((uint64_t)m_id);
	r += wiresize_u64((uint64_t)m_user);
	r += wiresize_u64((uint64_t)m_nice);
	r += wiresize_u64((uint64_t)m_system);
	r += wiresize_u64((uint64_t)m_idle);
	r += wiresize_u64((uint64_t)m_iowait);
	if (has_irq()) {
		r += wiresize_u64((uint64_t)m_irq) + 1 /* tag(id) 0x38 */;
	}
	if (has_vhost()) {
		r += wiresize_u64((uint64_t)m_vhost) + 1 /* tag(id) 0x40 */;
	}
	if (has_currtemp()) {
		r += wiresize_u64((uint64_t)m_currtemp) + 1 /* tag(id) 0x48 */;
	}
	if (has_crittemp()) {
		r += wiresize_u64((uint64_t)m_crittemp) + 1 /* tag(id) 0x50 */;
	}
	if (has_currmhz()) {
		r += wiresize_u64((uint64_t)m_currmhz) + 1 /* tag(id) 0x58 */;
	}
	return r;
}

size_t HostScope_LinuxCPU::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_LinuxCPU::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'id': id=1, encoding=0, tag=0x8
	a += varint2mem(a,e-a,0x8);	// 'id': id=1
	a += varint2mem(a,e-a,m_id);
	// 'user': id=2, encoding=0, tag=0x10
	a += varint2mem(a,e-a,0x10);	// 'user': id=2
	a += varint2mem(a,e-a,m_user);
	// 'nice': id=3, encoding=0, tag=0x18
	a += varint2mem(a,e-a,0x18);	// 'nice': id=3
	a += varint2mem(a,e-a,m_nice);
	// 'system': id=4, encoding=0, tag=0x20
	a += varint2mem(a,e-a,0x20);	// 'system': id=4
	a += varint2mem(a,e-a,m_system);
	// 'idle': id=5, encoding=0, tag=0x28
	a += varint2mem(a,e-a,0x28);	// 'idle': id=5
	a += varint2mem(a,e-a,m_idle);
	// 'iowait': id=6, encoding=0, tag=0x30
	a += varint2mem(a,e-a,0x30);	// 'iowait': id=6
	a += varint2mem(a,e-a,m_iowait);
	if (has_irq()) {
		// 'irq': id=7, encoding=0, tag=0x38
		a += varint2mem(a,e-a,0x38);	// 'irq': id=7
		a += varint2mem(a,e-a,m_irq);
	}
	if (has_vhost()) {
		// 'vhost': id=8, encoding=0, tag=0x40
		a += varint2mem(a,e-a,0x40);	// 'vhost': id=8
		a += varint2mem(a,e-a,m_vhost);
	}
	if (has_currtemp()) {
		// 'currtemp': id=9, encoding=0, tag=0x48
		a += varint2mem(a,e-a,0x48);	// 'currtemp': id=9
		a += varint2mem(a,e-a,m_currtemp);
	}
	if (has_crittemp()) {
		// 'crittemp': id=10, encoding=0, tag=0x50
		a += varint2mem(a,e-a,0x50);	// 'crittemp': id=10
		a += varint2mem(a,e-a,m_crittemp);
	}
	if (has_currmhz()) {
		// 'currmhz': id=11, encoding=0, tag=0x58
		a += varint2mem(a,e-a,0x58);	// 'currmhz': id=11
		a += varint2mem(a,e-a,m_currmhz);
	}
	assert(a <= e);
	return a-b;
}

uint32_t *HostScope_LinuxCPU::mutable_irq()
{
	if (0 == (p_validbits & ((uint8_t)1U << 0))) {
		m_irq = 0;
		p_validbits |= ((uint8_t)1U << 0);
	}
	return &m_irq;
}

void HostScope_LinuxCPU::set_irq(uint32_t  v)
{
	m_irq = v;
	p_validbits |= ((uint8_t)1U << 0);
}

uint32_t *HostScope_LinuxCPU::mutable_vhost()
{
	if (0 == (p_validbits & ((uint8_t)1U << 1))) {
		m_vhost = 0;
		p_validbits |= ((uint8_t)1U << 1);
	}
	return &m_vhost;
}

void HostScope_LinuxCPU::set_vhost(uint32_t  v)
{
	m_vhost = v;
	p_validbits |= ((uint8_t)1U << 1);
}

uint32_t *HostScope_LinuxCPU::mutable_currtemp()
{
	if (0 == (p_validbits & ((uint8_t)1U << 2))) {
		m_currtemp = 0;
		p_validbits |= ((uint8_t)1U << 2);
	}
	return &m_currtemp;
}

void HostScope_LinuxCPU::set_currtemp(uint32_t  v)
{
	m_currtemp = v;
	p_validbits |= ((uint8_t)1U << 2);
}

uint32_t *HostScope_LinuxCPU::mutable_crittemp()
{
	if (0 == (p_validbits & ((uint8_t)1U << 3))) {
		m_crittemp = 0;
		p_validbits |= ((uint8_t)1U << 3);
	}
	return &m_crittemp;
}

void HostScope_LinuxCPU::set_crittemp(uint32_t  v)
{
	m_crittemp = v;
	p_validbits |= ((uint8_t)1U << 3);
}

uint32_t *HostScope_LinuxCPU::mutable_currmhz()
{
	if (0 == (p_validbits & ((uint8_t)1U << 4))) {
		m_currmhz = 0;
		p_validbits |= ((uint8_t)1U << 4);
	}
	return &m_currmhz;
}

void HostScope_LinuxCPU::set_currmhz(uint32_t  v)
{
	m_currmhz = v;
	p_validbits |= ((uint8_t)1U << 4);
}

HostScope_Process::HostScope_Process()
: m_command()
, m_pid(0)
, m_uid(0)
, m_prio(0)
, m_nthreads(0)
, m_time(0)
, m_putime(0)
, m_pstime(0)
, m_virmem(0)
, m_rssmem(0)
, m_sharedmem(0)
, m_minflts(0)
, m_majflts(0)
, m_rchars(0)
, m_wchars(0)
, p_validbits(0)
{
}

void HostScope_Process::clear()
{
	m_command.clear();
	m_pid = 0;
	m_uid = 0;
	m_prio = 0;
	m_nthreads = 0;
	m_time = 0;
	m_putime = 0;
	m_pstime = 0;
	m_virmem = 0;
	m_rssmem = 0;
	m_sharedmem = 0;
	m_minflts = 0;
	m_majflts = 0;
	m_rchars = 0;
	m_wchars = 0;
	p_validbits = 0;
}

size_t HostScope_Process::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0xa:	// command id 1, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_command.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x10:	// pid id 2, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_pid = (uint32_t)v;
			}
			break;
		case 0x13:	// pid id 2, coding 8bit
			m_pid = (uint32_t)*a++;
			break;
		case 0x14:	// pid id 2, coding 16bit
			get_u16(a,(uint16_t*)&m_pid);
			a += 2;
			break;
		case 0x15:	// pid id 2, coding: 32bit
			get_u32(a,(uint32_t*)&m_pid);
			a += 4;
			break;
		case 0x18:	// uid id 3, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_uid = (uint32_t)v;
			}
			break;
		case 0x1b:	// uid id 3, coding 8bit
			m_uid = (uint32_t)*a++;
			break;
		case 0x1c:	// uid id 3, coding 16bit
			get_u16(a,(uint16_t*)&m_uid);
			a += 2;
			break;
		case 0x1d:	// uid id 3, coding: 32bit
			get_u32(a,(uint32_t*)&m_uid);
			a += 4;
			break;
		case 0x20:	// prio id 4, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_prio(v);
			}
			break;
		case 0x23:	// prio id 4, coding 8bit
			set_prio(*a++);
			break;
		case 0x24:	// prio id 4, coding 16bit
			set_prio(read_u16(a));
			a += 2;
			break;
		case 0x25:	// prio id 4, coding: 32bit
			set_prio(read_u32(a));
			a += 4;
			break;
		case 0x28:	// nthreads id 5, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nthreads(v);
			}
			break;
		case 0x2b:	// nthreads id 5, coding 8bit
			set_nthreads(*a++);
			break;
		case 0x2c:	// nthreads id 5, coding 16bit
			set_nthreads(read_u16(a));
			a += 2;
			break;
		case 0x2d:	// nthreads id 5, coding: 32bit
			set_nthreads(read_u32(a));
			a += 4;
			break;
		case 0x40:	// time id 8, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_time(v);
			}
			break;
		case 0x43:	// time id 8, coding 8bit
			set_time(*a++);
			break;
		case 0x44:	// time id 8, coding 16bit
			set_time(read_u16(a));
			a += 2;
			break;
		case 0x45:	// time id 8, coding: 32bit
			set_time(read_u32(a));
			a += 4;
			break;
		case 0x48:	// putime id 9, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_putime(v);
			}
			break;
		case 0x4b:	// putime id 9, coding 8bit
			set_putime(*a++);
			break;
		case 0x4c:	// putime id 9, coding 16bit
			set_putime(read_u16(a));
			a += 2;
			break;
		case 0x4d:	// putime id 9, coding: 32bit
			set_putime(read_u32(a));
			a += 4;
			break;
		case 0x50:	// pstime id 10, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_pstime(v);
			}
			break;
		case 0x53:	// pstime id 10, coding 8bit
			set_pstime(*a++);
			break;
		case 0x54:	// pstime id 10, coding 16bit
			set_pstime(read_u16(a));
			a += 2;
			break;
		case 0x55:	// pstime id 10, coding: 32bit
			set_pstime(read_u32(a));
			a += 4;
			break;
		case 0x80:	// virmem id 16, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_virmem(v);
			}
			break;
		case 0x83:	// virmem id 16, coding 8bit
			set_virmem(*a++);
			break;
		case 0x84:	// virmem id 16, coding 16bit
			set_virmem(read_u16(a));
			a += 2;
			break;
		case 0x85:	// virmem id 16, coding: 32bit
			set_virmem(read_u32(a));
			a += 4;
			break;
		case 0x88:	// rssmem id 17, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_rssmem(v);
			}
			break;
		case 0x8b:	// rssmem id 17, coding 8bit
			set_rssmem(*a++);
			break;
		case 0x8c:	// rssmem id 17, coding 16bit
			set_rssmem(read_u16(a));
			a += 2;
			break;
		case 0x8d:	// rssmem id 17, coding: 32bit
			set_rssmem(read_u32(a));
			a += 4;
			break;
		case 0x90:	// sharedmem id 18, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_sharedmem(v);
			}
			break;
		case 0x93:	// sharedmem id 18, coding 8bit
			set_sharedmem(*a++);
			break;
		case 0x94:	// sharedmem id 18, coding 16bit
			set_sharedmem(read_u16(a));
			a += 2;
			break;
		case 0x95:	// sharedmem id 18, coding: 32bit
			set_sharedmem(read_u32(a));
			a += 4;
			break;
		case 0xe0:	// minflts id 28, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_minflts(v);
			}
			break;
		case 0xe3:	// minflts id 28, coding 8bit
			set_minflts(*a++);
			break;
		case 0xe4:	// minflts id 28, coding 16bit
			set_minflts(read_u16(a));
			a += 2;
			break;
		case 0xe5:	// minflts id 28, coding: 32bit
			set_minflts(read_u32(a));
			a += 4;
			break;
		case 0xe8:	// majflts id 29, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_majflts(v);
			}
			break;
		case 0xeb:	// majflts id 29, coding 8bit
			set_majflts(*a++);
			break;
		case 0xec:	// majflts id 29, coding 16bit
			set_majflts(read_u16(a));
			a += 2;
			break;
		case 0xed:	// majflts id 29, coding: 32bit
			set_majflts(read_u32(a));
			a += 4;
			break;
		case 0xf0:	// rchars id 30, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_rchars(v);
			}
			break;
		case 0xf3:	// rchars id 30, coding 8bit
			set_rchars(*a++);
			break;
		case 0xf4:	// rchars id 30, coding 16bit
			set_rchars(read_u16(a));
			a += 2;
			break;
		case 0xf5:	// rchars id 30, coding: 32bit
			set_rchars(read_u32(a));
			a += 4;
			break;
		case 0xf8:	// wchars id 31, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_wchars(v);
			}
			break;
		case 0xfb:	// wchars id 31, coding 8bit
			set_wchars(*a++);
			break;
		case 0xfc:	// wchars id 31, coding 16bit
			set_wchars(read_u16(a));
			a += 2;
			break;
		case 0xfd:	// wchars id 31, coding: 32bit
			set_wchars(read_u32(a));
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_Process::calcSize() const
{
	// command: tagsize 1
	// pid: tagsize 1
	// uid: tagsize 1
	size_t r = 3;	// required size, default is fixed length
	size_t command_s = m_command.size();
	r += command_s + wiresize_u64(command_s);
	r += wiresize_u64((uint64_t)m_pid);
	r += wiresize_u64((uint64_t)m_uid);
	if (has_prio()) {
		r += wiresize_u64((uint64_t)m_prio) + 1 /* tag(id) 0x20 */;
	}
	if (has_nthreads()) {
		r += wiresize_u64((uint64_t)m_nthreads) + 1 /* tag(id) 0x28 */;
	}
	if (has_time()) {
		r += wiresize_u64((uint64_t)m_time) + 1 /* tag(id) 0x40 */;
	}
	if (has_putime()) {
		r += wiresize_u64((uint64_t)m_putime) + 1 /* tag(id) 0x48 */;
	}
	if (has_pstime()) {
		r += wiresize_u64((uint64_t)m_pstime) + 1 /* tag(id) 0x50 */;
	}
	if (has_virmem()) {
		r += wiresize_u64((uint64_t)m_virmem) + 2 /* tag(id) 0x80 */;
	}
	if (has_rssmem()) {
		r += wiresize_u64((uint64_t)m_rssmem) + 2 /* tag(id) 0x88 */;
	}
	if (has_sharedmem()) {
		r += wiresize_u64((uint64_t)m_sharedmem) + 2 /* tag(id) 0x90 */;
	}
	if (has_minflts()) {
		r += wiresize_u64((uint64_t)m_minflts) + 2 /* tag(id) 0xe0 */;
	}
	if (has_majflts()) {
		r += wiresize_u64((uint64_t)m_majflts) + 2 /* tag(id) 0xe8 */;
	}
	if (has_rchars()) {
		r += wiresize_u64((uint64_t)m_rchars) + 2 /* tag(id) 0xf0 */;
	}
	if (has_wchars()) {
		r += wiresize_u64((uint64_t)m_wchars) + 2 /* tag(id) 0xf8 */;
	}
	return r;
}

size_t HostScope_Process::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_Process::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'command': id=1, encoding=2, tag=0xa
	a += varint2mem(a,e-a,0xa);	// 'command': id=1
	size_t command_s = m_command.size();
	a += varint2mem(a,e-a,command_s);
	memcpy(a,m_command.data(),command_s);
	a += command_s;
	// 'pid': id=2, encoding=0, tag=0x10
	a += varint2mem(a,e-a,0x10);	// 'pid': id=2
	a += varint2mem(a,e-a,m_pid);
	// 'uid': id=3, encoding=0, tag=0x18
	a += varint2mem(a,e-a,0x18);	// 'uid': id=3
	a += varint2mem(a,e-a,m_uid);
	if (has_prio()) {
		// 'prio': id=4, encoding=0, tag=0x20
		a += varint2mem(a,e-a,0x20);	// 'prio': id=4
		a += varint2mem(a,e-a,m_prio);
	}
	if (has_nthreads()) {
		// 'nthreads': id=5, encoding=0, tag=0x28
		a += varint2mem(a,e-a,0x28);	// 'nthreads': id=5
		a += varint2mem(a,e-a,m_nthreads);
	}
	if (has_time()) {
		// 'time': id=8, encoding=0, tag=0x40
		a += varint2mem(a,e-a,0x40);	// 'time': id=8
		a += varint2mem(a,e-a,m_time);
	}
	if (has_putime()) {
		// 'putime': id=9, encoding=0, tag=0x48
		a += varint2mem(a,e-a,0x48);	// 'putime': id=9
		a += varint2mem(a,e-a,m_putime);
	}
	if (has_pstime()) {
		// 'pstime': id=10, encoding=0, tag=0x50
		a += varint2mem(a,e-a,0x50);	// 'pstime': id=10
		a += varint2mem(a,e-a,m_pstime);
	}
	if (has_virmem()) {
		// 'virmem': id=16, encoding=0, tag=0x80
		a += varint2mem(a,e-a,0x80);	// 'virmem': id=16
		a += varint2mem(a,e-a,m_virmem);
	}
	if (has_rssmem()) {
		// 'rssmem': id=17, encoding=0, tag=0x88
		a += varint2mem(a,e-a,0x88);	// 'rssmem': id=17
		a += varint2mem(a,e-a,m_rssmem);
	}
	if (has_sharedmem()) {
		// 'sharedmem': id=18, encoding=0, tag=0x90
		a += varint2mem(a,e-a,0x90);	// 'sharedmem': id=18
		a += varint2mem(a,e-a,m_sharedmem);
	}
	if (has_minflts()) {
		// 'minflts': id=28, encoding=0, tag=0xe0
		a += varint2mem(a,e-a,0xe0);	// 'minflts': id=28
		a += varint2mem(a,e-a,m_minflts);
	}
	if (has_majflts()) {
		// 'majflts': id=29, encoding=0, tag=0xe8
		a += varint2mem(a,e-a,0xe8);	// 'majflts': id=29
		a += varint2mem(a,e-a,m_majflts);
	}
	if (has_rchars()) {
		// 'rchars': id=30, encoding=0, tag=0xf0
		a += varint2mem(a,e-a,0xf0);	// 'rchars': id=30
		a += varint2mem(a,e-a,m_rchars);
	}
	if (has_wchars()) {
		// 'wchars': id=31, encoding=0, tag=0xf8
		a += varint2mem(a,e-a,0xf8);	// 'wchars': id=31
		a += varint2mem(a,e-a,m_wchars);
	}
	assert(a <= e);
	return a-b;
}

const std::string & HostScope_Process::command() const
{ return m_command; }

std::string *HostScope_Process::mutable_command()
{ return &m_command; }

void HostScope_Process::set_command(const std::string & v)
{ m_command = v; }

uint32_t *HostScope_Process::mutable_prio()
{
	if (0 == (p_validbits & ((uint16_t)1U << 0))) {
		m_prio = 0;
		p_validbits |= ((uint16_t)1U << 0);
	}
	return &m_prio;
}

void HostScope_Process::set_prio(uint32_t  v)
{
	m_prio = v;
	p_validbits |= ((uint16_t)1U << 0);
}

uint32_t *HostScope_Process::mutable_nthreads()
{
	if (0 == (p_validbits & ((uint16_t)1U << 1))) {
		m_nthreads = 0;
		p_validbits |= ((uint16_t)1U << 1);
	}
	return &m_nthreads;
}

void HostScope_Process::set_nthreads(uint32_t  v)
{
	m_nthreads = v;
	p_validbits |= ((uint16_t)1U << 1);
}

uint64_t *HostScope_Process::mutable_time()
{
	if (0 == (p_validbits & ((uint16_t)1U << 2))) {
		m_time = 0;
		p_validbits |= ((uint16_t)1U << 2);
	}
	return &m_time;
}

void HostScope_Process::set_time(uint64_t  v)
{
	m_time = v;
	p_validbits |= ((uint16_t)1U << 2);
}

uint32_t *HostScope_Process::mutable_putime()
{
	if (0 == (p_validbits & ((uint16_t)1U << 3))) {
		m_putime = 0;
		p_validbits |= ((uint16_t)1U << 3);
	}
	return &m_putime;
}

void HostScope_Process::set_putime(uint32_t  v)
{
	m_putime = v;
	p_validbits |= ((uint16_t)1U << 3);
}

uint32_t *HostScope_Process::mutable_pstime()
{
	if (0 == (p_validbits & ((uint16_t)1U << 4))) {
		m_pstime = 0;
		p_validbits |= ((uint16_t)1U << 4);
	}
	return &m_pstime;
}

void HostScope_Process::set_pstime(uint32_t  v)
{
	m_pstime = v;
	p_validbits |= ((uint16_t)1U << 4);
}

uint64_t *HostScope_Process::mutable_virmem()
{
	if (0 == (p_validbits & ((uint16_t)1U << 5))) {
		m_virmem = 0;
		p_validbits |= ((uint16_t)1U << 5);
	}
	return &m_virmem;
}

void HostScope_Process::set_virmem(uint64_t  v)
{
	m_virmem = v;
	p_validbits |= ((uint16_t)1U << 5);
}

uint64_t *HostScope_Process::mutable_rssmem()
{
	if (0 == (p_validbits & ((uint16_t)1U << 6))) {
		m_rssmem = 0;
		p_validbits |= ((uint16_t)1U << 6);
	}
	return &m_rssmem;
}

void HostScope_Process::set_rssmem(uint64_t  v)
{
	m_rssmem = v;
	p_validbits |= ((uint16_t)1U << 6);
}

uint64_t *HostScope_Process::mutable_sharedmem()
{
	if (0 == (p_validbits & ((uint16_t)1U << 7))) {
		m_sharedmem = 0;
		p_validbits |= ((uint16_t)1U << 7);
	}
	return &m_sharedmem;
}

void HostScope_Process::set_sharedmem(uint64_t  v)
{
	m_sharedmem = v;
	p_validbits |= ((uint16_t)1U << 7);
}

uint64_t *HostScope_Process::mutable_minflts()
{
	if (0 == (p_validbits & ((uint16_t)1U << 8))) {
		m_minflts = 0;
		p_validbits |= ((uint16_t)1U << 8);
	}
	return &m_minflts;
}

void HostScope_Process::set_minflts(uint64_t  v)
{
	m_minflts = v;
	p_validbits |= ((uint16_t)1U << 8);
}

uint64_t *HostScope_Process::mutable_majflts()
{
	if (0 == (p_validbits & ((uint16_t)1U << 9))) {
		m_majflts = 0;
		p_validbits |= ((uint16_t)1U << 9);
	}
	return &m_majflts;
}

void HostScope_Process::set_majflts(uint64_t  v)
{
	m_majflts = v;
	p_validbits |= ((uint16_t)1U << 9);
}

uint32_t *HostScope_Process::mutable_rchars()
{
	if (0 == (p_validbits & ((uint16_t)1U << 10))) {
		m_rchars = 0;
		p_validbits |= ((uint16_t)1U << 10);
	}
	return &m_rchars;
}

void HostScope_Process::set_rchars(uint32_t  v)
{
	m_rchars = v;
	p_validbits |= ((uint16_t)1U << 10);
}

uint32_t *HostScope_Process::mutable_wchars()
{
	if (0 == (p_validbits & ((uint16_t)1U << 11))) {
		m_wchars = 0;
		p_validbits |= ((uint16_t)1U << 11);
	}
	return &m_wchars;
}

void HostScope_Process::set_wchars(uint32_t  v)
{
	m_wchars = v;
	p_validbits |= ((uint16_t)1U << 11);
}

HostScope_User::HostScope_User()
: m_uid(0)
, m_name()
, m_nproc(0)
, m_nthreads(0)
, m_rssmem(0)
, m_sharedmem(0)
, m_minflts(0)
, m_majflts(0)
, m_putime(0)
, m_pstime(0)
, m_rchars(0)
, m_wchars(0)
, p_validbits(0)
{
}

void HostScope_User::clear()
{
	m_uid = 0;
	m_name.clear();
	m_nproc = 0;
	m_nthreads = 0;
	m_rssmem = 0;
	m_sharedmem = 0;
	m_minflts = 0;
	m_majflts = 0;
	m_putime = 0;
	m_pstime = 0;
	m_rchars = 0;
	m_wchars = 0;
	p_validbits = 0;
}

size_t HostScope_User::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0x8:	// uid id 1, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_uid = (uint32_t)v;
			}
			break;
		case 0xb:	// uid id 1, coding 8bit
			m_uid = (uint32_t)*a++;
			break;
		case 0xc:	// uid id 1, coding 16bit
			get_u16(a,(uint16_t*)&m_uid);
			a += 2;
			break;
		case 0xd:	// uid id 1, coding: 32bit
			get_u32(a,(uint32_t*)&m_uid);
			a += 4;
			break;
		case 0x12:	// name id 2, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_name.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x18:	// nproc id 3, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				m_nproc = (uint32_t)v;
			}
			break;
		case 0x1b:	// nproc id 3, coding 8bit
			m_nproc = (uint32_t)*a++;
			break;
		case 0x1c:	// nproc id 3, coding 16bit
			get_u16(a,(uint16_t*)&m_nproc);
			a += 2;
			break;
		case 0x1d:	// nproc id 3, coding: 32bit
			get_u32(a,(uint32_t*)&m_nproc);
			a += 4;
			break;
		case 0x20:	// nthreads id 4, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nthreads(v);
			}
			break;
		case 0x23:	// nthreads id 4, coding 8bit
			set_nthreads(*a++);
			break;
		case 0x24:	// nthreads id 4, coding 16bit
			set_nthreads(read_u16(a));
			a += 2;
			break;
		case 0x25:	// nthreads id 4, coding: 32bit
			set_nthreads(read_u32(a));
			a += 4;
			break;
		case 0x40:	// rssmem id 8, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_rssmem(v);
			}
			break;
		case 0x43:	// rssmem id 8, coding 8bit
			set_rssmem(*a++);
			break;
		case 0x44:	// rssmem id 8, coding 16bit
			set_rssmem(read_u16(a));
			a += 2;
			break;
		case 0x45:	// rssmem id 8, coding: 32bit
			set_rssmem(read_u32(a));
			a += 4;
			break;
		case 0x48:	// sharedmem id 9, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_sharedmem(v);
			}
			break;
		case 0x4b:	// sharedmem id 9, coding 8bit
			set_sharedmem(*a++);
			break;
		case 0x4c:	// sharedmem id 9, coding 16bit
			set_sharedmem(read_u16(a));
			a += 2;
			break;
		case 0x4d:	// sharedmem id 9, coding: 32bit
			set_sharedmem(read_u32(a));
			a += 4;
			break;
		case 0x60:	// minflts id 12, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_minflts(v);
			}
			break;
		case 0x63:	// minflts id 12, coding 8bit
			set_minflts(*a++);
			break;
		case 0x64:	// minflts id 12, coding 16bit
			set_minflts(read_u16(a));
			a += 2;
			break;
		case 0x65:	// minflts id 12, coding: 32bit
			set_minflts(read_u32(a));
			a += 4;
			break;
		case 0x68:	// majflts id 13, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_majflts(v);
			}
			break;
		case 0x6b:	// majflts id 13, coding 8bit
			set_majflts(*a++);
			break;
		case 0x6c:	// majflts id 13, coding 16bit
			set_majflts(read_u16(a));
			a += 2;
			break;
		case 0x6d:	// majflts id 13, coding: 32bit
			set_majflts(read_u32(a));
			a += 4;
			break;
		case 0x80:	// putime id 16, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_putime(v);
			}
			break;
		case 0x83:	// putime id 16, coding 8bit
			set_putime(*a++);
			break;
		case 0x84:	// putime id 16, coding 16bit
			set_putime(read_u16(a));
			a += 2;
			break;
		case 0x85:	// putime id 16, coding: 32bit
			set_putime(read_u32(a));
			a += 4;
			break;
		case 0x88:	// pstime id 17, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_pstime(v);
			}
			break;
		case 0x8b:	// pstime id 17, coding 8bit
			set_pstime(*a++);
			break;
		case 0x8c:	// pstime id 17, coding 16bit
			set_pstime(read_u16(a));
			a += 2;
			break;
		case 0x8d:	// pstime id 17, coding: 32bit
			set_pstime(read_u32(a));
			a += 4;
			break;
		case 0xa0:	// rchars id 20, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_rchars(v);
			}
			break;
		case 0xa3:	// rchars id 20, coding 8bit
			set_rchars(*a++);
			break;
		case 0xa4:	// rchars id 20, coding 16bit
			set_rchars(read_u16(a));
			a += 2;
			break;
		case 0xa5:	// rchars id 20, coding: 32bit
			set_rchars(read_u32(a));
			a += 4;
			break;
		case 0xa8:	// wchars id 21, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_wchars(v);
			}
			break;
		case 0xab:	// wchars id 21, coding 8bit
			set_wchars(*a++);
			break;
		case 0xac:	// wchars id 21, coding 16bit
			set_wchars(read_u16(a));
			a += 2;
			break;
		case 0xad:	// wchars id 21, coding: 32bit
			set_wchars(read_u32(a));
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_User::calcSize() const
{
	// uid: tagsize 1
	// name: tagsize 1
	// nproc: tagsize 1
	size_t r = 3;	// required size, default is fixed length
	r += wiresize_u64((uint64_t)m_uid);
	size_t name_s = m_name.size();
	r += name_s + wiresize_u64(name_s);
	r += wiresize_u64((uint64_t)m_nproc);
	if (has_nthreads()) {
		r += wiresize_u64((uint64_t)m_nthreads) + 1 /* tag(id) 0x20 */;
	}
	if (has_rssmem()) {
		r += wiresize_u64((uint64_t)m_rssmem) + 1 /* tag(id) 0x40 */;
	}
	if (has_sharedmem()) {
		r += wiresize_u64((uint64_t)m_sharedmem) + 1 /* tag(id) 0x48 */;
	}
	if (has_minflts()) {
		r += wiresize_u64((uint64_t)m_minflts) + 1 /* tag(id) 0x60 */;
	}
	if (has_majflts()) {
		r += wiresize_u64((uint64_t)m_majflts) + 1 /* tag(id) 0x68 */;
	}
	if (has_putime()) {
		r += wiresize_u64((uint64_t)m_putime) + 2 /* tag(id) 0x80 */;
	}
	if (has_pstime()) {
		r += wiresize_u64((uint64_t)m_pstime) + 2 /* tag(id) 0x88 */;
	}
	if (has_rchars()) {
		r += wiresize_u64((uint64_t)m_rchars) + 2 /* tag(id) 0xa0 */;
	}
	if (has_wchars()) {
		r += wiresize_u64((uint64_t)m_wchars) + 2 /* tag(id) 0xa8 */;
	}
	return r;
}

size_t HostScope_User::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_User::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'uid': id=1, encoding=0, tag=0x8
	a += varint2mem(a,e-a,0x8);	// 'uid': id=1
	a += varint2mem(a,e-a,m_uid);
	// 'name': id=2, encoding=2, tag=0x12
	a += varint2mem(a,e-a,0x12);	// 'name': id=2
	size_t name_s = m_name.size();
	a += varint2mem(a,e-a,name_s);
	memcpy(a,m_name.data(),name_s);
	a += name_s;
	// 'nproc': id=3, encoding=0, tag=0x18
	a += varint2mem(a,e-a,0x18);	// 'nproc': id=3
	a += varint2mem(a,e-a,m_nproc);
	if (has_nthreads()) {
		// 'nthreads': id=4, encoding=0, tag=0x20
		a += varint2mem(a,e-a,0x20);	// 'nthreads': id=4
		a += varint2mem(a,e-a,m_nthreads);
	}
	if (has_rssmem()) {
		// 'rssmem': id=8, encoding=0, tag=0x40
		a += varint2mem(a,e-a,0x40);	// 'rssmem': id=8
		a += varint2mem(a,e-a,m_rssmem);
	}
	if (has_sharedmem()) {
		// 'sharedmem': id=9, encoding=0, tag=0x48
		a += varint2mem(a,e-a,0x48);	// 'sharedmem': id=9
		a += varint2mem(a,e-a,m_sharedmem);
	}
	if (has_minflts()) {
		// 'minflts': id=12, encoding=0, tag=0x60
		a += varint2mem(a,e-a,0x60);	// 'minflts': id=12
		a += varint2mem(a,e-a,m_minflts);
	}
	if (has_majflts()) {
		// 'majflts': id=13, encoding=0, tag=0x68
		a += varint2mem(a,e-a,0x68);	// 'majflts': id=13
		a += varint2mem(a,e-a,m_majflts);
	}
	if (has_putime()) {
		// 'putime': id=16, encoding=0, tag=0x80
		a += varint2mem(a,e-a,0x80);	// 'putime': id=16
		a += varint2mem(a,e-a,m_putime);
	}
	if (has_pstime()) {
		// 'pstime': id=17, encoding=0, tag=0x88
		a += varint2mem(a,e-a,0x88);	// 'pstime': id=17
		a += varint2mem(a,e-a,m_pstime);
	}
	if (has_rchars()) {
		// 'rchars': id=20, encoding=0, tag=0xa0
		a += varint2mem(a,e-a,0xa0);	// 'rchars': id=20
		a += varint2mem(a,e-a,m_rchars);
	}
	if (has_wchars()) {
		// 'wchars': id=21, encoding=0, tag=0xa8
		a += varint2mem(a,e-a,0xa8);	// 'wchars': id=21
		a += varint2mem(a,e-a,m_wchars);
	}
	assert(a <= e);
	return a-b;
}

const std::string & HostScope_User::name() const
{ return m_name; }

std::string *HostScope_User::mutable_name()
{ return &m_name; }

void HostScope_User::set_name(const std::string & v)
{ m_name = v; }

uint32_t *HostScope_User::mutable_nthreads()
{
	if (0 == (p_validbits & ((uint16_t)1U << 0))) {
		m_nthreads = 0;
		p_validbits |= ((uint16_t)1U << 0);
	}
	return &m_nthreads;
}

void HostScope_User::set_nthreads(uint32_t  v)
{
	m_nthreads = v;
	p_validbits |= ((uint16_t)1U << 0);
}

uint64_t *HostScope_User::mutable_rssmem()
{
	if (0 == (p_validbits & ((uint16_t)1U << 1))) {
		m_rssmem = 0;
		p_validbits |= ((uint16_t)1U << 1);
	}
	return &m_rssmem;
}

void HostScope_User::set_rssmem(uint64_t  v)
{
	m_rssmem = v;
	p_validbits |= ((uint16_t)1U << 1);
}

uint64_t *HostScope_User::mutable_sharedmem()
{
	if (0 == (p_validbits & ((uint16_t)1U << 2))) {
		m_sharedmem = 0;
		p_validbits |= ((uint16_t)1U << 2);
	}
	return &m_sharedmem;
}

void HostScope_User::set_sharedmem(uint64_t  v)
{
	m_sharedmem = v;
	p_validbits |= ((uint16_t)1U << 2);
}

uint64_t *HostScope_User::mutable_minflts()
{
	if (0 == (p_validbits & ((uint16_t)1U << 3))) {
		m_minflts = 0;
		p_validbits |= ((uint16_t)1U << 3);
	}
	return &m_minflts;
}

void HostScope_User::set_minflts(uint64_t  v)
{
	m_minflts = v;
	p_validbits |= ((uint16_t)1U << 3);
}

uint64_t *HostScope_User::mutable_majflts()
{
	if (0 == (p_validbits & ((uint16_t)1U << 4))) {
		m_majflts = 0;
		p_validbits |= ((uint16_t)1U << 4);
	}
	return &m_majflts;
}

void HostScope_User::set_majflts(uint64_t  v)
{
	m_majflts = v;
	p_validbits |= ((uint16_t)1U << 4);
}

uint32_t *HostScope_User::mutable_putime()
{
	if (0 == (p_validbits & ((uint16_t)1U << 5))) {
		m_putime = 0;
		p_validbits |= ((uint16_t)1U << 5);
	}
	return &m_putime;
}

void HostScope_User::set_putime(uint32_t  v)
{
	m_putime = v;
	p_validbits |= ((uint16_t)1U << 5);
}

uint32_t *HostScope_User::mutable_pstime()
{
	if (0 == (p_validbits & ((uint16_t)1U << 6))) {
		m_pstime = 0;
		p_validbits |= ((uint16_t)1U << 6);
	}
	return &m_pstime;
}

void HostScope_User::set_pstime(uint32_t  v)
{
	m_pstime = v;
	p_validbits |= ((uint16_t)1U << 6);
}

uint32_t *HostScope_User::mutable_rchars()
{
	if (0 == (p_validbits & ((uint16_t)1U << 7))) {
		m_rchars = 0;
		p_validbits |= ((uint16_t)1U << 7);
	}
	return &m_rchars;
}

void HostScope_User::set_rchars(uint32_t  v)
{
	m_rchars = v;
	p_validbits |= ((uint16_t)1U << 7);
}

uint32_t *HostScope_User::mutable_wchars()
{
	if (0 == (p_validbits & ((uint16_t)1U << 8))) {
		m_wchars = 0;
		p_validbits |= ((uint16_t)1U << 8);
	}
	return &m_wchars;
}

void HostScope_User::set_wchars(uint32_t  v)
{
	m_wchars = v;
	p_validbits |= ((uint16_t)1U << 8);
}

HostScope_Disk::HostScope_Disk()
: m_devname()
, m_ktotal(0)
, m_nops(0)
, m_nread(0)
, m_nwrite(0)
, m_kread(0)
, m_kwrite(0)
, m_perc_busy(0)
, m_opsqueued(0)
, p_validbits(0)
{
}

void HostScope_Disk::clear()
{
	m_devname.clear();
	m_ktotal = 0;
	m_nops = 0;
	m_nread = 0;
	m_nwrite = 0;
	m_kread = 0;
	m_kwrite = 0;
	m_perc_busy = 0;
	m_opsqueued = 0;
	p_validbits = 0;
}

size_t HostScope_Disk::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0xa:	// devname id 1, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_devname.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x10:	// ktotal id 2, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_ktotal(v);
			}
			break;
		case 0x13:	// ktotal id 2, coding 8bit
			set_ktotal(*a++);
			break;
		case 0x14:	// ktotal id 2, coding 16bit
			set_ktotal(read_u16(a));
			a += 2;
			break;
		case 0x15:	// ktotal id 2, coding: 32bit
			set_ktotal(read_u32(a));
			a += 4;
			break;
		case 0x20:	// nops id 4, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nops(v);
			}
			break;
		case 0x23:	// nops id 4, coding 8bit
			set_nops(*a++);
			break;
		case 0x24:	// nops id 4, coding 16bit
			set_nops(read_u16(a));
			a += 2;
			break;
		case 0x25:	// nops id 4, coding: 32bit
			set_nops(read_u32(a));
			a += 4;
			break;
		case 0x28:	// nread id 5, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nread(v);
			}
			break;
		case 0x2b:	// nread id 5, coding 8bit
			set_nread(*a++);
			break;
		case 0x2c:	// nread id 5, coding 16bit
			set_nread(read_u16(a));
			a += 2;
			break;
		case 0x2d:	// nread id 5, coding: 32bit
			set_nread(read_u32(a));
			a += 4;
			break;
		case 0x30:	// nwrite id 6, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nwrite(v);
			}
			break;
		case 0x33:	// nwrite id 6, coding 8bit
			set_nwrite(*a++);
			break;
		case 0x34:	// nwrite id 6, coding 16bit
			set_nwrite(read_u16(a));
			a += 2;
			break;
		case 0x35:	// nwrite id 6, coding: 32bit
			set_nwrite(read_u32(a));
			a += 4;
			break;
		case 0x40:	// kread id 8, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_kread(v);
			}
			break;
		case 0x43:	// kread id 8, coding 8bit
			set_kread(*a++);
			break;
		case 0x44:	// kread id 8, coding 16bit
			set_kread(read_u16(a));
			a += 2;
			break;
		case 0x45:	// kread id 8, coding: 32bit
			set_kread(read_u32(a));
			a += 4;
			break;
		case 0x48:	// kwrite id 9, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_kwrite(v);
			}
			break;
		case 0x4b:	// kwrite id 9, coding 8bit
			set_kwrite(*a++);
			break;
		case 0x4c:	// kwrite id 9, coding 16bit
			set_kwrite(read_u16(a));
			a += 2;
			break;
		case 0x4d:	// kwrite id 9, coding: 32bit
			set_kwrite(read_u32(a));
			a += 4;
			break;
		case 0x50:	// perc_busy id 10, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_perc_busy(v);
			}
			break;
		case 0x53:	// perc_busy id 10, coding 8bit
			set_perc_busy(*a++);
			break;
		case 0x54:	// perc_busy id 10, coding 16bit
			set_perc_busy(read_u16(a));
			a += 2;
			break;
		case 0x55:	// perc_busy id 10, coding: 32bit
			set_perc_busy(read_u32(a));
			a += 4;
			break;
		case 0x60:	// opsqueued id 12, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_opsqueued(v);
			}
			break;
		case 0x63:	// opsqueued id 12, coding 8bit
			set_opsqueued(*a++);
			break;
		case 0x64:	// opsqueued id 12, coding 16bit
			set_opsqueued(read_u16(a));
			a += 2;
			break;
		case 0x65:	// opsqueued id 12, coding: 32bit
			set_opsqueued(read_u32(a));
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_Disk::calcSize() const
{
	// devname: tagsize 1
	size_t r = 1;	// required size, default is fixed length
	size_t devname_s = m_devname.size();
	r += devname_s + wiresize_u64(devname_s);
	if (has_ktotal()) {
		r += wiresize_u64((uint64_t)m_ktotal) + 1 /* tag(id) 0x10 */;
	}
	if (has_nops()) {
		r += wiresize_u64((uint64_t)m_nops) + 1 /* tag(id) 0x20 */;
	}
	if (has_nread()) {
		r += wiresize_u64((uint64_t)m_nread) + 1 /* tag(id) 0x28 */;
	}
	if (has_nwrite()) {
		r += wiresize_u64((uint64_t)m_nwrite) + 1 /* tag(id) 0x30 */;
	}
	if (has_kread()) {
		r += wiresize_u64((uint64_t)m_kread) + 1 /* tag(id) 0x40 */;
	}
	if (has_kwrite()) {
		r += wiresize_u64((uint64_t)m_kwrite) + 1 /* tag(id) 0x48 */;
	}
	if (has_perc_busy()) {
		r += wiresize_u64((uint64_t)m_perc_busy) + 1 /* tag(id) 0x50 */;
	}
	if (has_opsqueued()) {
		r += wiresize_u64((uint64_t)m_opsqueued) + 1 /* tag(id) 0x60 */;
	}
	return r;
}

size_t HostScope_Disk::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_Disk::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'devname': id=1, encoding=2, tag=0xa
	a += varint2mem(a,e-a,0xa);	// 'devname': id=1
	size_t devname_s = m_devname.size();
	a += varint2mem(a,e-a,devname_s);
	memcpy(a,m_devname.data(),devname_s);
	a += devname_s;
	if (has_ktotal()) {
		// 'ktotal': id=2, encoding=0, tag=0x10
		a += varint2mem(a,e-a,0x10);	// 'ktotal': id=2
		a += varint2mem(a,e-a,m_ktotal);
	}
	if (has_nops()) {
		// 'nops': id=4, encoding=0, tag=0x20
		a += varint2mem(a,e-a,0x20);	// 'nops': id=4
		a += varint2mem(a,e-a,m_nops);
	}
	if (has_nread()) {
		// 'nread': id=5, encoding=0, tag=0x28
		a += varint2mem(a,e-a,0x28);	// 'nread': id=5
		a += varint2mem(a,e-a,m_nread);
	}
	if (has_nwrite()) {
		// 'nwrite': id=6, encoding=0, tag=0x30
		a += varint2mem(a,e-a,0x30);	// 'nwrite': id=6
		a += varint2mem(a,e-a,m_nwrite);
	}
	if (has_kread()) {
		// 'kread': id=8, encoding=0, tag=0x40
		a += varint2mem(a,e-a,0x40);	// 'kread': id=8
		a += varint2mem(a,e-a,m_kread);
	}
	if (has_kwrite()) {
		// 'kwrite': id=9, encoding=0, tag=0x48
		a += varint2mem(a,e-a,0x48);	// 'kwrite': id=9
		a += varint2mem(a,e-a,m_kwrite);
	}
	if (has_perc_busy()) {
		// 'perc_busy': id=10, encoding=0, tag=0x50
		a += varint2mem(a,e-a,0x50);	// 'perc_busy': id=10
		a += varint2mem(a,e-a,m_perc_busy);
	}
	if (has_opsqueued()) {
		// 'opsqueued': id=12, encoding=0, tag=0x60
		a += varint2mem(a,e-a,0x60);	// 'opsqueued': id=12
		a += varint2mem(a,e-a,m_opsqueued);
	}
	assert(a <= e);
	return a-b;
}

const std::string & HostScope_Disk::devname() const
{ return m_devname; }

std::string *HostScope_Disk::mutable_devname()
{ return &m_devname; }

void HostScope_Disk::set_devname(const std::string & v)
{ m_devname = v; }

uint64_t *HostScope_Disk::mutable_ktotal()
{
	if (0 == (p_validbits & ((uint8_t)1U << 0))) {
		m_ktotal = 0;
		p_validbits |= ((uint8_t)1U << 0);
	}
	return &m_ktotal;
}

void HostScope_Disk::set_ktotal(uint64_t  v)
{
	m_ktotal = v;
	p_validbits |= ((uint8_t)1U << 0);
}

uint32_t *HostScope_Disk::mutable_nops()
{
	if (0 == (p_validbits & ((uint8_t)1U << 1))) {
		m_nops = 0;
		p_validbits |= ((uint8_t)1U << 1);
	}
	return &m_nops;
}

void HostScope_Disk::set_nops(uint32_t  v)
{
	m_nops = v;
	p_validbits |= ((uint8_t)1U << 1);
}

uint32_t *HostScope_Disk::mutable_nread()
{
	if (0 == (p_validbits & ((uint8_t)1U << 2))) {
		m_nread = 0;
		p_validbits |= ((uint8_t)1U << 2);
	}
	return &m_nread;
}

void HostScope_Disk::set_nread(uint32_t  v)
{
	m_nread = v;
	p_validbits |= ((uint8_t)1U << 2);
}

uint32_t *HostScope_Disk::mutable_nwrite()
{
	if (0 == (p_validbits & ((uint8_t)1U << 3))) {
		m_nwrite = 0;
		p_validbits |= ((uint8_t)1U << 3);
	}
	return &m_nwrite;
}

void HostScope_Disk::set_nwrite(uint32_t  v)
{
	m_nwrite = v;
	p_validbits |= ((uint8_t)1U << 3);
}

uint32_t *HostScope_Disk::mutable_kread()
{
	if (0 == (p_validbits & ((uint8_t)1U << 4))) {
		m_kread = 0;
		p_validbits |= ((uint8_t)1U << 4);
	}
	return &m_kread;
}

void HostScope_Disk::set_kread(uint32_t  v)
{
	m_kread = v;
	p_validbits |= ((uint8_t)1U << 4);
}

uint32_t *HostScope_Disk::mutable_kwrite()
{
	if (0 == (p_validbits & ((uint8_t)1U << 5))) {
		m_kwrite = 0;
		p_validbits |= ((uint8_t)1U << 5);
	}
	return &m_kwrite;
}

void HostScope_Disk::set_kwrite(uint32_t  v)
{
	m_kwrite = v;
	p_validbits |= ((uint8_t)1U << 5);
}

uint32_t *HostScope_Disk::mutable_perc_busy()
{
	if (0 == (p_validbits & ((uint8_t)1U << 6))) {
		m_perc_busy = 0;
		p_validbits |= ((uint8_t)1U << 6);
	}
	return &m_perc_busy;
}

void HostScope_Disk::set_perc_busy(uint32_t  v)
{
	m_perc_busy = v;
	p_validbits |= ((uint8_t)1U << 6);
}

uint32_t *HostScope_Disk::mutable_opsqueued()
{
	if (0 == (p_validbits & ((uint8_t)1U << 7))) {
		m_opsqueued = 0;
		p_validbits |= ((uint8_t)1U << 7);
	}
	return &m_opsqueued;
}

void HostScope_Disk::set_opsqueued(uint32_t  v)
{
	m_opsqueued = v;
	p_validbits |= ((uint8_t)1U << 7);
}

HostScope_NetDevice::HostScope_NetDevice()
: m_devname()
, m_nreceived(0)
, m_kreceived(0)
, m_ereceived(0)
, m_dreceived(0)
, m_ntransmit(0)
, m_ktransmit(0)
, m_etransmit(0)
, m_dtransmit(0)
, p_validbits(0)
{
}

void HostScope_NetDevice::clear()
{
	m_devname.clear();
	m_nreceived = 0;
	m_kreceived = 0;
	m_ereceived = 0;
	m_dreceived = 0;
	m_ntransmit = 0;
	m_ktransmit = 0;
	m_etransmit = 0;
	m_dtransmit = 0;
	p_validbits = 0;
}

size_t HostScope_NetDevice::fromMemory(const void *b, size_t s)
{
	clear();
	size_t n;
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		a += wire2varint(a,e-a,&fid);
		switch (fid) {
		case 0xa:	// devname id 1, coding byte[]
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert((n > 0) && (v >= 0));
				a += n;
				assert((a+v) <= e);
				m_devname.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x10:	// nreceived id 2, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_nreceived(v);
			}
			break;
		case 0x13:	// nreceived id 2, coding 8bit
			set_nreceived(*a++);
			break;
		case 0x14:	// nreceived id 2, coding 16bit
			set_nreceived(read_u16(a));
			a += 2;
			break;
		case 0x15:	// nreceived id 2, coding: 32bit
			set_nreceived(read_u32(a));
			a += 4;
			break;
		case 0x18:	// kreceived id 3, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_kreceived(v);
			}
			break;
		case 0x1b:	// kreceived id 3, coding 8bit
			set_kreceived(*a++);
			break;
		case 0x1c:	// kreceived id 3, coding 16bit
			set_kreceived(read_u16(a));
			a += 2;
			break;
		case 0x1d:	// kreceived id 3, coding: 32bit
			set_kreceived(read_u32(a));
			a += 4;
			break;
		case 0x20:	// ereceived id 4, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_ereceived(v);
			}
			break;
		case 0x23:	// ereceived id 4, coding 8bit
			set_ereceived(*a++);
			break;
		case 0x24:	// ereceived id 4, coding 16bit
			set_ereceived(read_u16(a));
			a += 2;
			break;
		case 0x25:	// ereceived id 4, coding: 32bit
			set_ereceived(read_u32(a));
			a += 4;
			break;
		case 0x28:	// dreceived id 5, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_dreceived(v);
			}
			break;
		case 0x2b:	// dreceived id 5, coding 8bit
			set_dreceived(*a++);
			break;
		case 0x2c:	// dreceived id 5, coding 16bit
			set_dreceived(read_u16(a));
			a += 2;
			break;
		case 0x2d:	// dreceived id 5, coding: 32bit
			set_dreceived(read_u32(a));
			a += 4;
			break;
		case 0x30:	// ntransmit id 6, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_ntransmit(v);
			}
			break;
		case 0x33:	// ntransmit id 6, coding 8bit
			set_ntransmit(*a++);
			break;
		case 0x34:	// ntransmit id 6, coding 16bit
			set_ntransmit(read_u16(a));
			a += 2;
			break;
		case 0x35:	// ntransmit id 6, coding: 32bit
			set_ntransmit(read_u32(a));
			a += 4;
			break;
		case 0x38:	// ktransmit id 7, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_ktransmit(v);
			}
			break;
		case 0x3b:	// ktransmit id 7, coding 8bit
			set_ktransmit(*a++);
			break;
		case 0x3c:	// ktransmit id 7, coding 16bit
			set_ktransmit(read_u16(a));
			a += 2;
			break;
		case 0x3d:	// ktransmit id 7, coding: 32bit
			set_ktransmit(read_u32(a));
			a += 4;
			break;
		case 0x40:	// etransmit id 8, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_etransmit(v);
			}
			break;
		case 0x43:	// etransmit id 8, coding 8bit
			set_etransmit(*a++);
			break;
		case 0x44:	// etransmit id 8, coding 16bit
			set_etransmit(read_u16(a));
			a += 2;
			break;
		case 0x45:	// etransmit id 8, coding: 32bit
			set_etransmit(read_u32(a));
			a += 4;
			break;
		case 0x48:	// dtransmit id 9, coding varint
			{
				varint_t v;
				n = wire2varint(a,e-a,&v);
				assert(n > 0);
				a += n;
				set_dtransmit(v);
			}
			break;
		case 0x4b:	// dtransmit id 9, coding 8bit
			set_dtransmit(*a++);
			break;
		case 0x4c:	// dtransmit id 9, coding 16bit
			set_dtransmit(read_u16(a));
			a += 2;
			break;
		case 0x4d:	// dtransmit id 9, coding: 32bit
			set_dtransmit(read_u32(a));
			a += 4;
			break;
		default:
			a += skip_field_xproto(a,e-a);
		}
	}
	return a-(const uint8_t *)b;
}

size_t HostScope_NetDevice::calcSize() const
{
	// devname: tagsize 1
	size_t r = 1;	// required size, default is fixed length
	size_t devname_s = m_devname.size();
	r += devname_s + wiresize_u64(devname_s);
	if (has_nreceived()) {
		r += wiresize_u64((uint64_t)m_nreceived) + 1 /* tag(id) 0x10 */;
	}
	if (has_kreceived()) {
		r += wiresize_u64((uint64_t)m_kreceived) + 1 /* tag(id) 0x18 */;
	}
	if (has_ereceived()) {
		r += wiresize_u64((uint64_t)m_ereceived) + 1 /* tag(id) 0x20 */;
	}
	if (has_dreceived()) {
		r += wiresize_u64((uint64_t)m_dreceived) + 1 /* tag(id) 0x28 */;
	}
	if (has_ntransmit()) {
		r += wiresize_u64((uint64_t)m_ntransmit) + 1 /* tag(id) 0x30 */;
	}
	if (has_ktransmit()) {
		r += wiresize_u64((uint64_t)m_ktransmit) + 1 /* tag(id) 0x38 */;
	}
	if (has_etransmit()) {
		r += wiresize_u64((uint64_t)m_etransmit) + 1 /* tag(id) 0x40 */;
	}
	if (has_dtransmit()) {
		r += wiresize_u64((uint64_t)m_dtransmit) + 1 /* tag(id) 0x48 */;
	}
	return r;
}

size_t HostScope_NetDevice::SerializeToString(std::string *str) const
{
	size_t s = calcSize();
	str->resize(s);
	uint8_t *buf = (uint8_t *)str->data();
	size_t w = toMemory(buf,s);
	assert(w == s);
	return w;
}

size_t HostScope_NetDevice::toMemory(uint8_t *b, size_t s) const
{
	uint8_t *e = b + s;
	uint8_t *a = b;
	// 'devname': id=1, encoding=2, tag=0xa
	a += varint2mem(a,e-a,0xa);	// 'devname': id=1
	size_t devname_s = m_devname.size();
	a += varint2mem(a,e-a,devname_s);
	memcpy(a,m_devname.data(),devname_s);
	a += devname_s;
	if (has_nreceived()) {
		// 'nreceived': id=2, encoding=0, tag=0x10
		a += varint2mem(a,e-a,0x10);	// 'nreceived': id=2
		a += varint2mem(a,e-a,m_nreceived);
	}
	if (has_kreceived()) {
		// 'kreceived': id=3, encoding=0, tag=0x18
		a += varint2mem(a,e-a,0x18);	// 'kreceived': id=3
		a += varint2mem(a,e-a,m_kreceived);
	}
	if (has_ereceived()) {
		// 'ereceived': id=4, encoding=0, tag=0x20
		a += varint2mem(a,e-a,0x20);	// 'ereceived': id=4
		a += varint2mem(a,e-a,m_ereceived);
	}
	if (has_dreceived()) {
		// 'dreceived': id=5, encoding=0, tag=0x28
		a += varint2mem(a,e-a,0x28);	// 'dreceived': id=5
		a += varint2mem(a,e-a,m_dreceived);
	}
	if (has_ntransmit()) {
		// 'ntransmit': id=6, encoding=0, tag=0x30
		a += varint2mem(a,e-a,0x30);	// 'ntransmit': id=6
		a += varint2mem(a,e-a,m_ntransmit);
	}
	if (has_ktransmit()) {
		// 'ktransmit': id=7, encoding=0, tag=0x38
		a += varint2mem(a,e-a,0x38);	// 'ktransmit': id=7
		a += varint2mem(a,e-a,m_ktransmit);
	}
	if (has_etransmit()) {
		// 'etransmit': id=8, encoding=0, tag=0x40
		a += varint2mem(a,e-a,0x40);	// 'etransmit': id=8
		a += varint2mem(a,e-a,m_etransmit);
	}
	if (has_dtransmit()) {
		// 'dtransmit': id=9, encoding=0, tag=0x48
		a += varint2mem(a,e-a,0x48);	// 'dtransmit': id=9
		a += varint2mem(a,e-a,m_dtransmit);
	}
	assert(a <= e);
	return a-b;
}

const std::string & HostScope_NetDevice::devname() const
{ return m_devname; }

std::string *HostScope_NetDevice::mutable_devname()
{ return &m_devname; }

void HostScope_NetDevice::set_devname(const std::string & v)
{ m_devname = v; }

uint32_t *HostScope_NetDevice::mutable_nreceived()
{
	if (0 == (p_validbits & ((uint8_t)1U << 0))) {
		m_nreceived = 0;
		p_validbits |= ((uint8_t)1U << 0);
	}
	return &m_nreceived;
}

void HostScope_NetDevice::set_nreceived(uint32_t  v)
{
	m_nreceived = v;
	p_validbits |= ((uint8_t)1U << 0);
}

uint32_t *HostScope_NetDevice::mutable_kreceived()
{
	if (0 == (p_validbits & ((uint8_t)1U << 1))) {
		m_kreceived = 0;
		p_validbits |= ((uint8_t)1U << 1);
	}
	return &m_kreceived;
}

void HostScope_NetDevice::set_kreceived(uint32_t  v)
{
	m_kreceived = v;
	p_validbits |= ((uint8_t)1U << 1);
}

uint32_t *HostScope_NetDevice::mutable_ereceived()
{
	if (0 == (p_validbits & ((uint8_t)1U << 2))) {
		m_ereceived = 0;
		p_validbits |= ((uint8_t)1U << 2);
	}
	return &m_ereceived;
}

void HostScope_NetDevice::set_ereceived(uint32_t  v)
{
	m_ereceived = v;
	p_validbits |= ((uint8_t)1U << 2);
}

uint32_t *HostScope_NetDevice::mutable_dreceived()
{
	if (0 == (p_validbits & ((uint8_t)1U << 3))) {
		m_dreceived = 0;
		p_validbits |= ((uint8_t)1U << 3);
	}
	return &m_dreceived;
}

void HostScope_NetDevice::set_dreceived(uint32_t  v)
{
	m_dreceived = v;
	p_validbits |= ((uint8_t)1U << 3);
}

uint32_t *HostScope_NetDevice::mutable_ntransmit()
{
	if (0 == (p_validbits & ((uint8_t)1U << 4))) {
		m_ntransmit = 0;
		p_validbits |= ((uint8_t)1U << 4);
	}
	return &m_ntransmit;
}

void HostScope_NetDevice::set_ntransmit(uint32_t  v)
{
	m_ntransmit = v;
	p_validbits |= ((uint8_t)1U << 4);
}

uint32_t *HostScope_NetDevice::mutable_ktransmit()
{
	if (0 == (p_validbits & ((uint8_t)1U << 5))) {
		m_ktransmit = 0;
		p_validbits |= ((uint8_t)1U << 5);
	}
	return &m_ktransmit;
}

void HostScope_NetDevice::set_ktransmit(uint32_t  v)
{
	m_ktransmit = v;
	p_validbits |= ((uint8_t)1U << 5);
}

uint32_t *HostScope_NetDevice::mutable_etransmit()
{
	if (0 == (p_validbits & ((uint8_t)1U << 6))) {
		m_etransmit = 0;
		p_validbits |= ((uint8_t)1U << 6);
	}
	return &m_etransmit;
}

void HostScope_NetDevice::set_etransmit(uint32_t  v)
{
	m_etransmit = v;
	p_validbits |= ((uint8_t)1U << 6);
}

uint32_t *HostScope_NetDevice::mutable_dtransmit()
{
	if (0 == (p_validbits & ((uint8_t)1U << 7))) {
		m_dtransmit = 0;
		p_validbits |= ((uint8_t)1U << 7);
	}
	return &m_dtransmit;
}

void HostScope_NetDevice::set_dtransmit(uint32_t  v)
{
	m_dtransmit = v;
	p_validbits |= ((uint8_t)1U << 7);
}

