/*
 * Copyright (C) 2017, Thomas Maier-Komor (maier-komor.de)
 * 
 * Code generated with Wire-Format-Compiler V0.2.0/hg:afdb8c6821e9
 * License ID: 17491
 */

/********************************************************************************
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/


/*
 * options from commandline:
 * 
 * options from file:hostscope.wfc:
 * toASCII         : ""
 * toWire          : ""
 * 
 * options from defaults:
 * AddPrefix       : "add_"
 * bytestype       : "std"
 * ClearName       : "clear"
 * ClearPrefix     : "clear_"
 * endian          : "unknown"
 * fromMemory      : "fromMemory"
 * GetPrefix       : ""
 * HasPrefix       : "has_"
 * intsize         : 32
 * MutablePrefix   : "mutable_"
 * namespace       : ""
 * SetPrefix       : "set_"
 * SortMembers     : "id"
 * stringtype      : "std"
 * syntax          : "xprotov1"
 * toMemory        : "toMemory"
 * unknown         : "skip"
 * VarIntBits      : 64
 * wireput         : ""
 * 
 * disabled flags from defaults:
 * 	cc_generic_services, checks, Debug, SubClasses, withEqual, withUnequal
 * enabled flags from defaults:
 * 	Asserts, StringSerialization
 */

#ifndef HOSTSCOPE_WFC_H
#define HOSTSCOPE_WFC_H

#include <string>
/* wfc support functions not needed */
#include <vector>
/* array support not needed */
#include <stdlib.h>
#include <stdint.h>

#define VARINTBITS 64
#define HAVE_TO_MEMORY 1
#define HAVE_TO_WIRE 1
#define HAVE_FROM_MEMORY 1

typedef uint64_t varint_t;


class HostScope_MetaData
{
	public:
	HostScope_MetaData();
	
	bool operator != (const HostScope_MetaData &r) const;
	bool operator == (const HostScope_MetaData &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_protocol_version() const;
	uint32_t protocol_version() const;
	void set_protocol_version(uint32_t  v);
	uint32_t* mutable_protocol_version();
	
	bool has_timestamp() const;
	uint64_t timestamp() const;
	void set_timestamp(uint64_t  v);
	uint64_t* mutable_timestamp();
	
	bool has_hostscope_version() const;
	const std::string &hostscope_version() const;
	void set_hostscope_version(const std::string & v);
	std::string* mutable_hostscope_version();
	
	
	protected:
	uint32_t m_protocol_version;
	uint64_t m_timestamp;
	std::string m_hostscope_version;
};


class HostScope_HostInfo
{
	public:
	HostScope_HostInfo();
	
	bool operator != (const HostScope_HostInfo &r) const;
	bool operator == (const HostScope_HostInfo &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_hostname() const;
	const std::string &hostname() const;
	void set_hostname(const std::string & v);
	std::string* mutable_hostname();
	
	bool has_uptime() const;
	uint64_t uptime() const;
	void set_uptime(uint64_t  v);
	uint64_t* mutable_uptime();
	
	bool has_osname() const;
	const std::string &osname() const;
	void set_osname(const std::string & v);
	std::string* mutable_osname();
	
	bool has_osrelease() const;
	const std::string &osrelease() const;
	void set_osrelease(const std::string & v);
	std::string* mutable_osrelease();
	
	bool has_osversion() const;
	const std::string &osversion() const;
	void set_osversion(const std::string & v);
	std::string* mutable_osversion();
	
	bool has_proctype() const;
	const std::string &proctype() const;
	void set_proctype(const std::string & v);
	std::string* mutable_proctype();
	
	bool has_machtype() const;
	const std::string &machtype() const;
	void set_machtype(const std::string & v);
	std::string* mutable_machtype();
	
	bool has_minuseruid() const;
	void clear_minuseruid();
	uint32_t minuseruid() const;
	void set_minuseruid(uint32_t  v);
	uint32_t* mutable_minuseruid();
	
	
	protected:
	std::string m_hostname;
	uint64_t m_uptime;
	std::string m_osname;
	std::string m_osrelease;
	std::string m_osversion;
	std::string m_proctype;
	std::string m_machtype;
	uint32_t m_minuseruid;
	
	private:
	uint8_t p_validbits;
};


class HostScope_LoadAvg
{
	public:
	HostScope_LoadAvg();
	
	bool operator != (const HostScope_LoadAvg &r) const;
	bool operator == (const HostScope_LoadAvg &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_loadav1m() const;
	uint32_t loadav1m() const;
	void set_loadav1m(uint32_t  v);
	uint32_t* mutable_loadav1m();
	
	bool has_loadav5m() const;
	uint32_t loadav5m() const;
	void set_loadav5m(uint32_t  v);
	uint32_t* mutable_loadav5m();
	
	bool has_loadav15m() const;
	uint32_t loadav15m() const;
	void set_loadav15m(uint32_t  v);
	uint32_t* mutable_loadav15m();
	
	
	protected:
	uint32_t m_loadav1m;
	uint32_t m_loadav5m;
	uint32_t m_loadav15m;
};


class HostScope_Memory
{
	public:
	HostScope_Memory();
	
	bool operator != (const HostScope_Memory &r) const;
	bool operator == (const HostScope_Memory &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_physical() const;
	void clear_physical();
	uint64_t physical() const;
	void set_physical(uint64_t  v);
	uint64_t* mutable_physical();
	
	bool has_free() const;
	void clear_free();
	uint64_t free() const;
	void set_free(uint64_t  v);
	uint64_t* mutable_free();
	
	bool has_swapsize() const;
	void clear_swapsize();
	uint64_t swapsize() const;
	void set_swapsize(uint64_t  v);
	uint64_t* mutable_swapsize();
	
	bool has_pagedout() const;
	void clear_pagedout();
	uint64_t pagedout() const;
	void set_pagedout(uint64_t  v);
	uint64_t* mutable_pagedout();
	
	bool has_locked() const;
	void clear_locked();
	uint64_t locked() const;
	void set_locked(uint64_t  v);
	uint64_t* mutable_locked();
	
	
	protected:
	uint64_t m_physical;
	uint64_t m_free;
	uint64_t m_swapsize;
	uint64_t m_pagedout;
	uint64_t m_locked;
	
	private:
	uint8_t p_validbits;
};


class HostScope_PowerSupply
{
	public:
	HostScope_PowerSupply();
	
	bool operator != (const HostScope_PowerSupply &r) const;
	bool operator == (const HostScope_PowerSupply &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_name() const;
	const std::string &name() const;
	void set_name(const std::string & v);
	std::string* mutable_name();
	
	bool has_state() const;
	const std::string &state() const;
	void set_state(const std::string & v);
	std::string* mutable_state();
	
	bool has_capacity() const;
	void clear_capacity();
	uint32_t capacity() const;
	void set_capacity(uint32_t  v);
	uint32_t* mutable_capacity();
	
	
	protected:
	std::string m_name;
	std::string m_state;
	uint32_t m_capacity;
	
	private:
	uint8_t p_validbits;
};


class HostScope_LinuxInfo
{
	public:
	HostScope_LinuxInfo();
	
	bool operator != (const HostScope_LinuxInfo &r) const;
	bool operator == (const HostScope_LinuxInfo &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_forks() const;
	uint32_t forks() const;
	void set_forks(uint32_t  v);
	uint32_t* mutable_forks();
	
	bool has_ctxtsw() const;
	uint32_t ctxtsw() const;
	void set_ctxtsw(uint32_t  v);
	uint32_t* mutable_ctxtsw();
	
	bool has_intrs() const;
	uint32_t intrs() const;
	void set_intrs(uint32_t  v);
	uint32_t* mutable_intrs();
	
	bool has_sirqs() const;
	uint32_t sirqs() const;
	void set_sirqs(uint32_t  v);
	uint32_t* mutable_sirqs();
	
	
	protected:
	uint32_t m_forks;
	uint32_t m_ctxtsw;
	uint32_t m_intrs;
	uint32_t m_sirqs;
};


class HostScope_LinuxVmstat
{
	public:
	HostScope_LinuxVmstat();
	
	bool operator != (const HostScope_LinuxVmstat &r) const;
	bool operator == (const HostScope_LinuxVmstat &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_nr_free_pages() const;
	void clear_nr_free_pages();
	uint64_t nr_free_pages() const;
	void set_nr_free_pages(uint64_t  v);
	uint64_t* mutable_nr_free_pages();
	
	bool has_nr_mlock() const;
	void clear_nr_mlock();
	uint64_t nr_mlock() const;
	void set_nr_mlock(uint64_t  v);
	uint64_t* mutable_nr_mlock();
	
	bool has_nr_anon_pages() const;
	void clear_nr_anon_pages();
	uint64_t nr_anon_pages() const;
	void set_nr_anon_pages(uint64_t  v);
	uint64_t* mutable_nr_anon_pages();
	
	bool has_nr_file_pages() const;
	void clear_nr_file_pages();
	uint64_t nr_file_pages() const;
	void set_nr_file_pages(uint64_t  v);
	uint64_t* mutable_nr_file_pages();
	
	bool has_nr_kernel_stack() const;
	void clear_nr_kernel_stack();
	uint64_t nr_kernel_stack() const;
	void set_nr_kernel_stack(uint64_t  v);
	uint64_t* mutable_nr_kernel_stack();
	
	bool has_nr_shmem() const;
	void clear_nr_shmem();
	uint64_t nr_shmem() const;
	void set_nr_shmem(uint64_t  v);
	uint64_t* mutable_nr_shmem();
	
	bool has_pgpgin() const;
	void clear_pgpgin();
	uint64_t pgpgin() const;
	void set_pgpgin(uint64_t  v);
	uint64_t* mutable_pgpgin();
	
	bool has_pgpgout() const;
	void clear_pgpgout();
	uint64_t pgpgout() const;
	void set_pgpgout(uint64_t  v);
	uint64_t* mutable_pgpgout();
	
	bool has_pgfree() const;
	void clear_pgfree();
	uint64_t pgfree() const;
	void set_pgfree(uint64_t  v);
	uint64_t* mutable_pgfree();
	
	bool has_pgfault() const;
	void clear_pgfault();
	uint64_t pgfault() const;
	void set_pgfault(uint64_t  v);
	uint64_t* mutable_pgfault();
	
	bool has_pgmajfault() const;
	void clear_pgmajfault();
	uint64_t pgmajfault() const;
	void set_pgmajfault(uint64_t  v);
	uint64_t* mutable_pgmajfault();
	
	
	protected:
	uint64_t m_nr_free_pages;
	uint64_t m_nr_mlock;
	uint64_t m_nr_anon_pages;
	uint64_t m_nr_file_pages;
	uint64_t m_nr_kernel_stack;
	uint64_t m_nr_shmem;
	uint64_t m_pgpgin;
	uint64_t m_pgpgout;
	uint64_t m_pgfree;
	uint64_t m_pgfault;
	uint64_t m_pgmajfault;
	
	private:
	uint16_t p_validbits;
};


class HostScope_LinuxCPU
{
	public:
	HostScope_LinuxCPU();
	
	bool operator != (const HostScope_LinuxCPU &r) const;
	bool operator == (const HostScope_LinuxCPU &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_id() const;
	uint32_t id() const;
	void set_id(uint32_t  v);
	uint32_t* mutable_id();
	
	bool has_user() const;
	uint32_t user() const;
	void set_user(uint32_t  v);
	uint32_t* mutable_user();
	
	bool has_nice() const;
	uint32_t nice() const;
	void set_nice(uint32_t  v);
	uint32_t* mutable_nice();
	
	bool has_system() const;
	uint32_t system() const;
	void set_system(uint32_t  v);
	uint32_t* mutable_system();
	
	bool has_idle() const;
	uint32_t idle() const;
	void set_idle(uint32_t  v);
	uint32_t* mutable_idle();
	
	bool has_iowait() const;
	uint32_t iowait() const;
	void set_iowait(uint32_t  v);
	uint32_t* mutable_iowait();
	
	bool has_irq() const;
	void clear_irq();
	uint32_t irq() const;
	void set_irq(uint32_t  v);
	uint32_t* mutable_irq();
	
	bool has_vhost() const;
	void clear_vhost();
	uint32_t vhost() const;
	void set_vhost(uint32_t  v);
	uint32_t* mutable_vhost();
	
	bool has_currtemp() const;
	void clear_currtemp();
	uint32_t currtemp() const;
	void set_currtemp(uint32_t  v);
	uint32_t* mutable_currtemp();
	
	bool has_crittemp() const;
	void clear_crittemp();
	uint32_t crittemp() const;
	void set_crittemp(uint32_t  v);
	uint32_t* mutable_crittemp();
	
	bool has_currmhz() const;
	void clear_currmhz();
	uint32_t currmhz() const;
	void set_currmhz(uint32_t  v);
	uint32_t* mutable_currmhz();
	
	
	protected:
	uint32_t m_id;
	uint32_t m_user;
	uint32_t m_nice;
	uint32_t m_system;
	uint32_t m_idle;
	uint32_t m_iowait;
	uint32_t m_irq;
	uint32_t m_vhost;
	uint32_t m_currtemp;
	uint32_t m_crittemp;
	uint32_t m_currmhz;
	
	private:
	uint8_t p_validbits;
};


class HostScope_Process
{
	public:
	HostScope_Process();
	
	bool operator != (const HostScope_Process &r) const;
	bool operator == (const HostScope_Process &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_command() const;
	const std::string &command() const;
	void set_command(const std::string & v);
	std::string* mutable_command();
	
	bool has_pid() const;
	uint32_t pid() const;
	void set_pid(uint32_t  v);
	uint32_t* mutable_pid();
	
	bool has_uid() const;
	uint32_t uid() const;
	void set_uid(uint32_t  v);
	uint32_t* mutable_uid();
	
	bool has_prio() const;
	void clear_prio();
	uint32_t prio() const;
	void set_prio(uint32_t  v);
	uint32_t* mutable_prio();
	
	bool has_nthreads() const;
	void clear_nthreads();
	uint32_t nthreads() const;
	void set_nthreads(uint32_t  v);
	uint32_t* mutable_nthreads();
	
	bool has_time() const;
	void clear_time();
	uint64_t time() const;
	void set_time(uint64_t  v);
	uint64_t* mutable_time();
	
	bool has_putime() const;
	void clear_putime();
	uint32_t putime() const;
	void set_putime(uint32_t  v);
	uint32_t* mutable_putime();
	
	bool has_pstime() const;
	void clear_pstime();
	uint32_t pstime() const;
	void set_pstime(uint32_t  v);
	uint32_t* mutable_pstime();
	
	bool has_virmem() const;
	void clear_virmem();
	uint64_t virmem() const;
	void set_virmem(uint64_t  v);
	uint64_t* mutable_virmem();
	
	bool has_rssmem() const;
	void clear_rssmem();
	uint64_t rssmem() const;
	void set_rssmem(uint64_t  v);
	uint64_t* mutable_rssmem();
	
	bool has_sharedmem() const;
	void clear_sharedmem();
	uint64_t sharedmem() const;
	void set_sharedmem(uint64_t  v);
	uint64_t* mutable_sharedmem();
	
	bool has_minflts() const;
	void clear_minflts();
	uint64_t minflts() const;
	void set_minflts(uint64_t  v);
	uint64_t* mutable_minflts();
	
	bool has_majflts() const;
	void clear_majflts();
	uint64_t majflts() const;
	void set_majflts(uint64_t  v);
	uint64_t* mutable_majflts();
	
	bool has_rchars() const;
	void clear_rchars();
	uint32_t rchars() const;
	void set_rchars(uint32_t  v);
	uint32_t* mutable_rchars();
	
	bool has_wchars() const;
	void clear_wchars();
	uint32_t wchars() const;
	void set_wchars(uint32_t  v);
	uint32_t* mutable_wchars();
	
	
	protected:
	std::string m_command;
	uint32_t m_pid;
	uint32_t m_uid;
	uint32_t m_prio;
	uint32_t m_nthreads;
	uint64_t m_time;
	uint32_t m_putime;
	uint32_t m_pstime;
	uint64_t m_virmem;
	uint64_t m_rssmem;
	uint64_t m_sharedmem;
	uint64_t m_minflts;
	uint64_t m_majflts;
	uint32_t m_rchars;
	uint32_t m_wchars;
	
	private:
	uint16_t p_validbits;
};


class HostScope_User
{
	public:
	HostScope_User();
	
	bool operator != (const HostScope_User &r) const;
	bool operator == (const HostScope_User &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_uid() const;
	uint32_t uid() const;
	void set_uid(uint32_t  v);
	uint32_t* mutable_uid();
	
	bool has_name() const;
	const std::string &name() const;
	void set_name(const std::string & v);
	std::string* mutable_name();
	
	bool has_nproc() const;
	uint32_t nproc() const;
	void set_nproc(uint32_t  v);
	uint32_t* mutable_nproc();
	
	bool has_nthreads() const;
	void clear_nthreads();
	uint32_t nthreads() const;
	void set_nthreads(uint32_t  v);
	uint32_t* mutable_nthreads();
	
	bool has_rssmem() const;
	void clear_rssmem();
	uint64_t rssmem() const;
	void set_rssmem(uint64_t  v);
	uint64_t* mutable_rssmem();
	
	bool has_sharedmem() const;
	void clear_sharedmem();
	uint64_t sharedmem() const;
	void set_sharedmem(uint64_t  v);
	uint64_t* mutable_sharedmem();
	
	bool has_minflts() const;
	void clear_minflts();
	uint64_t minflts() const;
	void set_minflts(uint64_t  v);
	uint64_t* mutable_minflts();
	
	bool has_majflts() const;
	void clear_majflts();
	uint64_t majflts() const;
	void set_majflts(uint64_t  v);
	uint64_t* mutable_majflts();
	
	bool has_putime() const;
	void clear_putime();
	uint32_t putime() const;
	void set_putime(uint32_t  v);
	uint32_t* mutable_putime();
	
	bool has_pstime() const;
	void clear_pstime();
	uint32_t pstime() const;
	void set_pstime(uint32_t  v);
	uint32_t* mutable_pstime();
	
	bool has_rchars() const;
	void clear_rchars();
	uint32_t rchars() const;
	void set_rchars(uint32_t  v);
	uint32_t* mutable_rchars();
	
	bool has_wchars() const;
	void clear_wchars();
	uint32_t wchars() const;
	void set_wchars(uint32_t  v);
	uint32_t* mutable_wchars();
	
	
	protected:
	uint32_t m_uid;
	std::string m_name;
	uint32_t m_nproc;
	uint32_t m_nthreads;
	uint64_t m_rssmem;
	uint64_t m_sharedmem;
	uint64_t m_minflts;
	uint64_t m_majflts;
	uint32_t m_putime;
	uint32_t m_pstime;
	uint32_t m_rchars;
	uint32_t m_wchars;
	
	private:
	uint16_t p_validbits;
};


class HostScope_Disk
{
	public:
	HostScope_Disk();
	
	bool operator != (const HostScope_Disk &r) const;
	bool operator == (const HostScope_Disk &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_devname() const;
	const std::string &devname() const;
	void set_devname(const std::string & v);
	std::string* mutable_devname();
	
	bool has_ktotal() const;
	void clear_ktotal();
	uint64_t ktotal() const;
	void set_ktotal(uint64_t  v);
	uint64_t* mutable_ktotal();
	
	bool has_nops() const;
	void clear_nops();
	uint32_t nops() const;
	void set_nops(uint32_t  v);
	uint32_t* mutable_nops();
	
	bool has_nread() const;
	void clear_nread();
	uint32_t nread() const;
	void set_nread(uint32_t  v);
	uint32_t* mutable_nread();
	
	bool has_nwrite() const;
	void clear_nwrite();
	uint32_t nwrite() const;
	void set_nwrite(uint32_t  v);
	uint32_t* mutable_nwrite();
	
	bool has_kread() const;
	void clear_kread();
	uint32_t kread() const;
	void set_kread(uint32_t  v);
	uint32_t* mutable_kread();
	
	bool has_kwrite() const;
	void clear_kwrite();
	uint32_t kwrite() const;
	void set_kwrite(uint32_t  v);
	uint32_t* mutable_kwrite();
	
	bool has_perc_busy() const;
	void clear_perc_busy();
	uint32_t perc_busy() const;
	void set_perc_busy(uint32_t  v);
	uint32_t* mutable_perc_busy();
	
	bool has_opsqueued() const;
	void clear_opsqueued();
	uint32_t opsqueued() const;
	void set_opsqueued(uint32_t  v);
	uint32_t* mutable_opsqueued();
	
	
	protected:
	std::string m_devname;
	uint64_t m_ktotal;
	uint32_t m_nops;
	uint32_t m_nread;
	uint32_t m_nwrite;
	uint32_t m_kread;
	uint32_t m_kwrite;
	uint32_t m_perc_busy;
	uint32_t m_opsqueued;
	
	private:
	uint8_t p_validbits;
};


class HostScope_NetDevice
{
	public:
	HostScope_NetDevice();
	
	bool operator != (const HostScope_NetDevice &r) const;
	bool operator == (const HostScope_NetDevice &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_devname() const;
	const std::string &devname() const;
	void set_devname(const std::string & v);
	std::string* mutable_devname();
	
	bool has_nreceived() const;
	void clear_nreceived();
	uint32_t nreceived() const;
	void set_nreceived(uint32_t  v);
	uint32_t* mutable_nreceived();
	
	bool has_kreceived() const;
	void clear_kreceived();
	uint32_t kreceived() const;
	void set_kreceived(uint32_t  v);
	uint32_t* mutable_kreceived();
	
	bool has_ereceived() const;
	void clear_ereceived();
	uint32_t ereceived() const;
	void set_ereceived(uint32_t  v);
	uint32_t* mutable_ereceived();
	
	bool has_dreceived() const;
	void clear_dreceived();
	uint32_t dreceived() const;
	void set_dreceived(uint32_t  v);
	uint32_t* mutable_dreceived();
	
	bool has_ntransmit() const;
	void clear_ntransmit();
	uint32_t ntransmit() const;
	void set_ntransmit(uint32_t  v);
	uint32_t* mutable_ntransmit();
	
	bool has_ktransmit() const;
	void clear_ktransmit();
	uint32_t ktransmit() const;
	void set_ktransmit(uint32_t  v);
	uint32_t* mutable_ktransmit();
	
	bool has_etransmit() const;
	void clear_etransmit();
	uint32_t etransmit() const;
	void set_etransmit(uint32_t  v);
	uint32_t* mutable_etransmit();
	
	bool has_dtransmit() const;
	void clear_dtransmit();
	uint32_t dtransmit() const;
	void set_dtransmit(uint32_t  v);
	uint32_t* mutable_dtransmit();
	
	
	protected:
	std::string m_devname;
	uint32_t m_nreceived;
	uint32_t m_kreceived;
	uint32_t m_ereceived;
	uint32_t m_dreceived;
	uint32_t m_ntransmit;
	uint32_t m_ktransmit;
	uint32_t m_etransmit;
	uint32_t m_dtransmit;
	
	private:
	uint8_t p_validbits;
};


class HostScope
{
	public:
	HostScope();
	
	bool operator != (const HostScope &r) const;
	bool operator == (const HostScope &r) const;
	void clear();
	size_t calcSize() const;
	size_t fromMemory(const void *b, size_t s);
	size_t toMemory(uint8_t *, size_t) const;
	size_t SerializeToString(std::string *) const;
	bool has_metadata() const;
	const HostScope_MetaData &metadata() const;
	void set_metadata(const HostScope_MetaData & v);
	HostScope_MetaData* mutable_metadata();
	
	bool has_hostinfo() const;
	const HostScope_HostInfo &hostinfo() const;
	void set_hostinfo(const HostScope_HostInfo & v);
	HostScope_HostInfo* mutable_hostinfo();
	
	bool has_loadavg() const;
	void clear_loadavg();
	const HostScope_LoadAvg &loadavg() const;
	void set_loadavg(const HostScope_LoadAvg & v);
	HostScope_LoadAvg* mutable_loadavg();
	
	bool has_mem() const;
	void clear_mem();
	const HostScope_Memory &mem() const;
	void set_mem(const HostScope_Memory & v);
	HostScope_Memory* mutable_mem();
	
	bool has_power_supplies() const;
	size_t power_supplies_size() const;
	HostScope_PowerSupply* add_power_supplies();
	void clear_power_supplies();
	const HostScope_PowerSupply &power_supplies(unsigned x) const;
	void set_power_supplies(unsigned x, const HostScope_PowerSupply & v);
	HostScope_PowerSupply* mutable_power_supplies(unsigned x);
	
	bool has_linux_info() const;
	void clear_linux_info();
	const HostScope_LinuxInfo &linux_info() const;
	void set_linux_info(const HostScope_LinuxInfo & v);
	HostScope_LinuxInfo* mutable_linux_info();
	
	bool has_linux_vmstat() const;
	void clear_linux_vmstat();
	const HostScope_LinuxVmstat &linux_vmstat() const;
	void set_linux_vmstat(const HostScope_LinuxVmstat & v);
	HostScope_LinuxVmstat* mutable_linux_vmstat();
	
	bool has_linux_cpus() const;
	size_t linux_cpus_size() const;
	HostScope_LinuxCPU* add_linux_cpus();
	void clear_linux_cpus();
	const HostScope_LinuxCPU &linux_cpus(unsigned x) const;
	void set_linux_cpus(unsigned x, const HostScope_LinuxCPU & v);
	HostScope_LinuxCPU* mutable_linux_cpus(unsigned x);
	
	bool has_processes() const;
	size_t processes_size() const;
	HostScope_Process* add_processes();
	void clear_processes();
	const HostScope_Process &processes(unsigned x) const;
	void set_processes(unsigned x, const HostScope_Process & v);
	HostScope_Process* mutable_processes(unsigned x);
	
	bool has_users() const;
	size_t users_size() const;
	HostScope_User* add_users();
	void clear_users();
	const HostScope_User &users(unsigned x) const;
	void set_users(unsigned x, const HostScope_User & v);
	HostScope_User* mutable_users(unsigned x);
	
	bool has_disks() const;
	size_t disks_size() const;
	HostScope_Disk* add_disks();
	void clear_disks();
	const HostScope_Disk &disks(unsigned x) const;
	void set_disks(unsigned x, const HostScope_Disk & v);
	HostScope_Disk* mutable_disks(unsigned x);
	
	bool has_netdevices() const;
	size_t netdevices_size() const;
	HostScope_NetDevice* add_netdevices();
	void clear_netdevices();
	const HostScope_NetDevice &netdevices(unsigned x) const;
	void set_netdevices(unsigned x, const HostScope_NetDevice & v);
	HostScope_NetDevice* mutable_netdevices(unsigned x);
	
	
	protected:
	HostScope_MetaData m_metadata;
	HostScope_HostInfo m_hostinfo;
	HostScope_LoadAvg m_loadavg;
	HostScope_Memory m_mem;
	std::vector<HostScope_PowerSupply> m_power_supplies;
	HostScope_LinuxInfo m_linux_info;
	HostScope_LinuxVmstat m_linux_vmstat;
	std::vector<HostScope_LinuxCPU> m_linux_cpus;
	std::vector<HostScope_Process> m_processes;
	std::vector<HostScope_User> m_users;
	std::vector<HostScope_Disk> m_disks;
	std::vector<HostScope_NetDevice> m_netdevices;
	
	private:
	uint8_t p_validbits;
};




inline bool HostScope_MetaData::has_protocol_version() const
{ return true; }

inline uint32_t  HostScope_MetaData::protocol_version() const
{ return m_protocol_version; }

inline uint32_t *HostScope_MetaData::mutable_protocol_version()
{ return &m_protocol_version; }

inline void HostScope_MetaData::set_protocol_version(uint32_t  v)
{ m_protocol_version = v; }

inline bool HostScope_MetaData::has_timestamp() const
{ return true; }

inline uint64_t  HostScope_MetaData::timestamp() const
{ return m_timestamp; }

inline uint64_t *HostScope_MetaData::mutable_timestamp()
{ return &m_timestamp; }

inline void HostScope_MetaData::set_timestamp(uint64_t  v)
{ m_timestamp = v; }

inline bool HostScope_MetaData::has_hostscope_version() const
{ return !m_hostscope_version.empty(); }


inline bool HostScope_HostInfo::has_hostname() const
{ return !m_hostname.empty(); }

inline bool HostScope_HostInfo::has_uptime() const
{ return true; }

inline uint64_t  HostScope_HostInfo::uptime() const
{ return m_uptime; }

inline uint64_t *HostScope_HostInfo::mutable_uptime()
{ return &m_uptime; }

inline void HostScope_HostInfo::set_uptime(uint64_t  v)
{ m_uptime = v; }

inline bool HostScope_HostInfo::has_osname() const
{ return !m_osname.empty(); }

inline bool HostScope_HostInfo::has_osrelease() const
{ return (!m_osrelease.empty()); }

inline bool HostScope_HostInfo::has_osversion() const
{ return (!m_osversion.empty()); }

inline bool HostScope_HostInfo::has_proctype() const
{ return (!m_proctype.empty()); }

inline bool HostScope_HostInfo::has_machtype() const
{ return (!m_machtype.empty()); }

inline bool HostScope_HostInfo::has_minuseruid() const
{ return (0 != (p_validbits & ((uint8_t)1U << 0))); }

inline uint32_t  HostScope_HostInfo::minuseruid() const
{ return m_minuseruid; }

inline void HostScope_HostInfo::clear_minuseruid()
{ p_validbits &= ~((uint8_t)1U << 0); }


inline bool HostScope_LoadAvg::has_loadav1m() const
{ return true; }

inline uint32_t  HostScope_LoadAvg::loadav1m() const
{ return m_loadav1m; }

inline uint32_t *HostScope_LoadAvg::mutable_loadav1m()
{ return &m_loadav1m; }

inline void HostScope_LoadAvg::set_loadav1m(uint32_t  v)
{ m_loadav1m = v; }

inline bool HostScope_LoadAvg::has_loadav5m() const
{ return true; }

inline uint32_t  HostScope_LoadAvg::loadav5m() const
{ return m_loadav5m; }

inline uint32_t *HostScope_LoadAvg::mutable_loadav5m()
{ return &m_loadav5m; }

inline void HostScope_LoadAvg::set_loadav5m(uint32_t  v)
{ m_loadav5m = v; }

inline bool HostScope_LoadAvg::has_loadav15m() const
{ return true; }

inline uint32_t  HostScope_LoadAvg::loadav15m() const
{ return m_loadav15m; }

inline uint32_t *HostScope_LoadAvg::mutable_loadav15m()
{ return &m_loadav15m; }

inline void HostScope_LoadAvg::set_loadav15m(uint32_t  v)
{ m_loadav15m = v; }


inline bool HostScope_Memory::has_physical() const
{ return (0 != (p_validbits & ((uint8_t)1U << 0))); }

inline uint64_t  HostScope_Memory::physical() const
{ return m_physical; }

inline void HostScope_Memory::clear_physical()
{ p_validbits &= ~((uint8_t)1U << 0); }

inline bool HostScope_Memory::has_free() const
{ return (0 != (p_validbits & ((uint8_t)1U << 1))); }

inline uint64_t  HostScope_Memory::free() const
{ return m_free; }

inline void HostScope_Memory::clear_free()
{ p_validbits &= ~((uint8_t)1U << 1); }

inline bool HostScope_Memory::has_swapsize() const
{ return (0 != (p_validbits & ((uint8_t)1U << 2))); }

inline uint64_t  HostScope_Memory::swapsize() const
{ return m_swapsize; }

inline void HostScope_Memory::clear_swapsize()
{ p_validbits &= ~((uint8_t)1U << 2); }

inline bool HostScope_Memory::has_pagedout() const
{ return (0 != (p_validbits & ((uint8_t)1U << 3))); }

inline uint64_t  HostScope_Memory::pagedout() const
{ return m_pagedout; }

inline void HostScope_Memory::clear_pagedout()
{ p_validbits &= ~((uint8_t)1U << 3); }

inline bool HostScope_Memory::has_locked() const
{ return (0 != (p_validbits & ((uint8_t)1U << 4))); }

inline uint64_t  HostScope_Memory::locked() const
{ return m_locked; }

inline void HostScope_Memory::clear_locked()
{ p_validbits &= ~((uint8_t)1U << 4); }


inline bool HostScope_PowerSupply::has_name() const
{ return !m_name.empty(); }

inline bool HostScope_PowerSupply::has_state() const
{ return !m_state.empty(); }

inline bool HostScope_PowerSupply::has_capacity() const
{ return (0 != (p_validbits & ((uint8_t)1U << 0))); }

inline uint32_t  HostScope_PowerSupply::capacity() const
{ return m_capacity; }

inline void HostScope_PowerSupply::clear_capacity()
{ p_validbits &= ~((uint8_t)1U << 0); }


inline bool HostScope_LinuxInfo::has_forks() const
{ return true; }

inline uint32_t  HostScope_LinuxInfo::forks() const
{ return m_forks; }

inline uint32_t *HostScope_LinuxInfo::mutable_forks()
{ return &m_forks; }

inline void HostScope_LinuxInfo::set_forks(uint32_t  v)
{ m_forks = v; }

inline bool HostScope_LinuxInfo::has_ctxtsw() const
{ return true; }

inline uint32_t  HostScope_LinuxInfo::ctxtsw() const
{ return m_ctxtsw; }

inline uint32_t *HostScope_LinuxInfo::mutable_ctxtsw()
{ return &m_ctxtsw; }

inline void HostScope_LinuxInfo::set_ctxtsw(uint32_t  v)
{ m_ctxtsw = v; }

inline bool HostScope_LinuxInfo::has_intrs() const
{ return true; }

inline uint32_t  HostScope_LinuxInfo::intrs() const
{ return m_intrs; }

inline uint32_t *HostScope_LinuxInfo::mutable_intrs()
{ return &m_intrs; }

inline void HostScope_LinuxInfo::set_intrs(uint32_t  v)
{ m_intrs = v; }

inline bool HostScope_LinuxInfo::has_sirqs() const
{ return true; }

inline uint32_t  HostScope_LinuxInfo::sirqs() const
{ return m_sirqs; }

inline uint32_t *HostScope_LinuxInfo::mutable_sirqs()
{ return &m_sirqs; }

inline void HostScope_LinuxInfo::set_sirqs(uint32_t  v)
{ m_sirqs = v; }


inline bool HostScope_LinuxVmstat::has_nr_free_pages() const
{ return (0 != (p_validbits & ((uint16_t)1U << 0))); }

inline uint64_t  HostScope_LinuxVmstat::nr_free_pages() const
{ return m_nr_free_pages; }

inline void HostScope_LinuxVmstat::clear_nr_free_pages()
{ p_validbits &= ~((uint16_t)1U << 0); }

inline bool HostScope_LinuxVmstat::has_nr_mlock() const
{ return (0 != (p_validbits & ((uint16_t)1U << 1))); }

inline uint64_t  HostScope_LinuxVmstat::nr_mlock() const
{ return m_nr_mlock; }

inline void HostScope_LinuxVmstat::clear_nr_mlock()
{ p_validbits &= ~((uint16_t)1U << 1); }

inline bool HostScope_LinuxVmstat::has_nr_anon_pages() const
{ return (0 != (p_validbits & ((uint16_t)1U << 2))); }

inline uint64_t  HostScope_LinuxVmstat::nr_anon_pages() const
{ return m_nr_anon_pages; }

inline void HostScope_LinuxVmstat::clear_nr_anon_pages()
{ p_validbits &= ~((uint16_t)1U << 2); }

inline bool HostScope_LinuxVmstat::has_nr_file_pages() const
{ return (0 != (p_validbits & ((uint16_t)1U << 3))); }

inline uint64_t  HostScope_LinuxVmstat::nr_file_pages() const
{ return m_nr_file_pages; }

inline void HostScope_LinuxVmstat::clear_nr_file_pages()
{ p_validbits &= ~((uint16_t)1U << 3); }

inline bool HostScope_LinuxVmstat::has_nr_kernel_stack() const
{ return (0 != (p_validbits & ((uint16_t)1U << 4))); }

inline uint64_t  HostScope_LinuxVmstat::nr_kernel_stack() const
{ return m_nr_kernel_stack; }

inline void HostScope_LinuxVmstat::clear_nr_kernel_stack()
{ p_validbits &= ~((uint16_t)1U << 4); }

inline bool HostScope_LinuxVmstat::has_nr_shmem() const
{ return (0 != (p_validbits & ((uint16_t)1U << 5))); }

inline uint64_t  HostScope_LinuxVmstat::nr_shmem() const
{ return m_nr_shmem; }

inline void HostScope_LinuxVmstat::clear_nr_shmem()
{ p_validbits &= ~((uint16_t)1U << 5); }

inline bool HostScope_LinuxVmstat::has_pgpgin() const
{ return (0 != (p_validbits & ((uint16_t)1U << 6))); }

inline uint64_t  HostScope_LinuxVmstat::pgpgin() const
{ return m_pgpgin; }

inline void HostScope_LinuxVmstat::clear_pgpgin()
{ p_validbits &= ~((uint16_t)1U << 6); }

inline bool HostScope_LinuxVmstat::has_pgpgout() const
{ return (0 != (p_validbits & ((uint16_t)1U << 7))); }

inline uint64_t  HostScope_LinuxVmstat::pgpgout() const
{ return m_pgpgout; }

inline void HostScope_LinuxVmstat::clear_pgpgout()
{ p_validbits &= ~((uint16_t)1U << 7); }

inline bool HostScope_LinuxVmstat::has_pgfree() const
{ return (0 != (p_validbits & ((uint16_t)1U << 8))); }

inline uint64_t  HostScope_LinuxVmstat::pgfree() const
{ return m_pgfree; }

inline void HostScope_LinuxVmstat::clear_pgfree()
{ p_validbits &= ~((uint16_t)1U << 8); }

inline bool HostScope_LinuxVmstat::has_pgfault() const
{ return (0 != (p_validbits & ((uint16_t)1U << 9))); }

inline uint64_t  HostScope_LinuxVmstat::pgfault() const
{ return m_pgfault; }

inline void HostScope_LinuxVmstat::clear_pgfault()
{ p_validbits &= ~((uint16_t)1U << 9); }

inline bool HostScope_LinuxVmstat::has_pgmajfault() const
{ return (0 != (p_validbits & ((uint16_t)1U << 10))); }

inline uint64_t  HostScope_LinuxVmstat::pgmajfault() const
{ return m_pgmajfault; }

inline void HostScope_LinuxVmstat::clear_pgmajfault()
{ p_validbits &= ~((uint16_t)1U << 10); }


inline bool HostScope_LinuxCPU::has_id() const
{ return true; }

inline uint32_t  HostScope_LinuxCPU::id() const
{ return m_id; }

inline uint32_t *HostScope_LinuxCPU::mutable_id()
{ return &m_id; }

inline void HostScope_LinuxCPU::set_id(uint32_t  v)
{ m_id = v; }

inline bool HostScope_LinuxCPU::has_user() const
{ return true; }

inline uint32_t  HostScope_LinuxCPU::user() const
{ return m_user; }

inline uint32_t *HostScope_LinuxCPU::mutable_user()
{ return &m_user; }

inline void HostScope_LinuxCPU::set_user(uint32_t  v)
{ m_user = v; }

inline bool HostScope_LinuxCPU::has_nice() const
{ return true; }

inline uint32_t  HostScope_LinuxCPU::nice() const
{ return m_nice; }

inline uint32_t *HostScope_LinuxCPU::mutable_nice()
{ return &m_nice; }

inline void HostScope_LinuxCPU::set_nice(uint32_t  v)
{ m_nice = v; }

inline bool HostScope_LinuxCPU::has_system() const
{ return true; }

inline uint32_t  HostScope_LinuxCPU::system() const
{ return m_system; }

inline uint32_t *HostScope_LinuxCPU::mutable_system()
{ return &m_system; }

inline void HostScope_LinuxCPU::set_system(uint32_t  v)
{ m_system = v; }

inline bool HostScope_LinuxCPU::has_idle() const
{ return true; }

inline uint32_t  HostScope_LinuxCPU::idle() const
{ return m_idle; }

inline uint32_t *HostScope_LinuxCPU::mutable_idle()
{ return &m_idle; }

inline void HostScope_LinuxCPU::set_idle(uint32_t  v)
{ m_idle = v; }

inline bool HostScope_LinuxCPU::has_iowait() const
{ return true; }

inline uint32_t  HostScope_LinuxCPU::iowait() const
{ return m_iowait; }

inline uint32_t *HostScope_LinuxCPU::mutable_iowait()
{ return &m_iowait; }

inline void HostScope_LinuxCPU::set_iowait(uint32_t  v)
{ m_iowait = v; }

inline bool HostScope_LinuxCPU::has_irq() const
{ return (0 != (p_validbits & ((uint8_t)1U << 0))); }

inline uint32_t  HostScope_LinuxCPU::irq() const
{ return m_irq; }

inline void HostScope_LinuxCPU::clear_irq()
{ p_validbits &= ~((uint8_t)1U << 0); }

inline bool HostScope_LinuxCPU::has_vhost() const
{ return (0 != (p_validbits & ((uint8_t)1U << 1))); }

inline uint32_t  HostScope_LinuxCPU::vhost() const
{ return m_vhost; }

inline void HostScope_LinuxCPU::clear_vhost()
{ p_validbits &= ~((uint8_t)1U << 1); }

inline bool HostScope_LinuxCPU::has_currtemp() const
{ return (0 != (p_validbits & ((uint8_t)1U << 2))); }

inline uint32_t  HostScope_LinuxCPU::currtemp() const
{ return m_currtemp; }

inline void HostScope_LinuxCPU::clear_currtemp()
{ p_validbits &= ~((uint8_t)1U << 2); }

inline bool HostScope_LinuxCPU::has_crittemp() const
{ return (0 != (p_validbits & ((uint8_t)1U << 3))); }

inline uint32_t  HostScope_LinuxCPU::crittemp() const
{ return m_crittemp; }

inline void HostScope_LinuxCPU::clear_crittemp()
{ p_validbits &= ~((uint8_t)1U << 3); }

inline bool HostScope_LinuxCPU::has_currmhz() const
{ return (0 != (p_validbits & ((uint8_t)1U << 4))); }

inline uint32_t  HostScope_LinuxCPU::currmhz() const
{ return m_currmhz; }

inline void HostScope_LinuxCPU::clear_currmhz()
{ p_validbits &= ~((uint8_t)1U << 4); }


inline bool HostScope_Process::has_command() const
{ return !m_command.empty(); }

inline bool HostScope_Process::has_pid() const
{ return true; }

inline uint32_t  HostScope_Process::pid() const
{ return m_pid; }

inline uint32_t *HostScope_Process::mutable_pid()
{ return &m_pid; }

inline void HostScope_Process::set_pid(uint32_t  v)
{ m_pid = v; }

inline bool HostScope_Process::has_uid() const
{ return true; }

inline uint32_t  HostScope_Process::uid() const
{ return m_uid; }

inline uint32_t *HostScope_Process::mutable_uid()
{ return &m_uid; }

inline void HostScope_Process::set_uid(uint32_t  v)
{ m_uid = v; }

inline bool HostScope_Process::has_prio() const
{ return (0 != (p_validbits & ((uint16_t)1U << 0))); }

inline uint32_t  HostScope_Process::prio() const
{ return m_prio; }

inline void HostScope_Process::clear_prio()
{ p_validbits &= ~((uint16_t)1U << 0); }

inline bool HostScope_Process::has_nthreads() const
{ return (0 != (p_validbits & ((uint16_t)1U << 1))); }

inline uint32_t  HostScope_Process::nthreads() const
{ return m_nthreads; }

inline void HostScope_Process::clear_nthreads()
{ p_validbits &= ~((uint16_t)1U << 1); }

inline bool HostScope_Process::has_time() const
{ return (0 != (p_validbits & ((uint16_t)1U << 2))); }

inline uint64_t  HostScope_Process::time() const
{ return m_time; }

inline void HostScope_Process::clear_time()
{ p_validbits &= ~((uint16_t)1U << 2); }

inline bool HostScope_Process::has_putime() const
{ return (0 != (p_validbits & ((uint16_t)1U << 3))); }

inline uint32_t  HostScope_Process::putime() const
{ return m_putime; }

inline void HostScope_Process::clear_putime()
{ p_validbits &= ~((uint16_t)1U << 3); }

inline bool HostScope_Process::has_pstime() const
{ return (0 != (p_validbits & ((uint16_t)1U << 4))); }

inline uint32_t  HostScope_Process::pstime() const
{ return m_pstime; }

inline void HostScope_Process::clear_pstime()
{ p_validbits &= ~((uint16_t)1U << 4); }

inline bool HostScope_Process::has_virmem() const
{ return (0 != (p_validbits & ((uint16_t)1U << 5))); }

inline uint64_t  HostScope_Process::virmem() const
{ return m_virmem; }

inline void HostScope_Process::clear_virmem()
{ p_validbits &= ~((uint16_t)1U << 5); }

inline bool HostScope_Process::has_rssmem() const
{ return (0 != (p_validbits & ((uint16_t)1U << 6))); }

inline uint64_t  HostScope_Process::rssmem() const
{ return m_rssmem; }

inline void HostScope_Process::clear_rssmem()
{ p_validbits &= ~((uint16_t)1U << 6); }

inline bool HostScope_Process::has_sharedmem() const
{ return (0 != (p_validbits & ((uint16_t)1U << 7))); }

inline uint64_t  HostScope_Process::sharedmem() const
{ return m_sharedmem; }

inline void HostScope_Process::clear_sharedmem()
{ p_validbits &= ~((uint16_t)1U << 7); }

inline bool HostScope_Process::has_minflts() const
{ return (0 != (p_validbits & ((uint16_t)1U << 8))); }

inline uint64_t  HostScope_Process::minflts() const
{ return m_minflts; }

inline void HostScope_Process::clear_minflts()
{ p_validbits &= ~((uint16_t)1U << 8); }

inline bool HostScope_Process::has_majflts() const
{ return (0 != (p_validbits & ((uint16_t)1U << 9))); }

inline uint64_t  HostScope_Process::majflts() const
{ return m_majflts; }

inline void HostScope_Process::clear_majflts()
{ p_validbits &= ~((uint16_t)1U << 9); }

inline bool HostScope_Process::has_rchars() const
{ return (0 != (p_validbits & ((uint16_t)1U << 10))); }

inline uint32_t  HostScope_Process::rchars() const
{ return m_rchars; }

inline void HostScope_Process::clear_rchars()
{ p_validbits &= ~((uint16_t)1U << 10); }

inline bool HostScope_Process::has_wchars() const
{ return (0 != (p_validbits & ((uint16_t)1U << 11))); }

inline uint32_t  HostScope_Process::wchars() const
{ return m_wchars; }

inline void HostScope_Process::clear_wchars()
{ p_validbits &= ~((uint16_t)1U << 11); }


inline bool HostScope_User::has_uid() const
{ return true; }

inline uint32_t  HostScope_User::uid() const
{ return m_uid; }

inline uint32_t *HostScope_User::mutable_uid()
{ return &m_uid; }

inline void HostScope_User::set_uid(uint32_t  v)
{ m_uid = v; }

inline bool HostScope_User::has_name() const
{ return !m_name.empty(); }

inline bool HostScope_User::has_nproc() const
{ return true; }

inline uint32_t  HostScope_User::nproc() const
{ return m_nproc; }

inline uint32_t *HostScope_User::mutable_nproc()
{ return &m_nproc; }

inline void HostScope_User::set_nproc(uint32_t  v)
{ m_nproc = v; }

inline bool HostScope_User::has_nthreads() const
{ return (0 != (p_validbits & ((uint16_t)1U << 0))); }

inline uint32_t  HostScope_User::nthreads() const
{ return m_nthreads; }

inline void HostScope_User::clear_nthreads()
{ p_validbits &= ~((uint16_t)1U << 0); }

inline bool HostScope_User::has_rssmem() const
{ return (0 != (p_validbits & ((uint16_t)1U << 1))); }

inline uint64_t  HostScope_User::rssmem() const
{ return m_rssmem; }

inline void HostScope_User::clear_rssmem()
{ p_validbits &= ~((uint16_t)1U << 1); }

inline bool HostScope_User::has_sharedmem() const
{ return (0 != (p_validbits & ((uint16_t)1U << 2))); }

inline uint64_t  HostScope_User::sharedmem() const
{ return m_sharedmem; }

inline void HostScope_User::clear_sharedmem()
{ p_validbits &= ~((uint16_t)1U << 2); }

inline bool HostScope_User::has_minflts() const
{ return (0 != (p_validbits & ((uint16_t)1U << 3))); }

inline uint64_t  HostScope_User::minflts() const
{ return m_minflts; }

inline void HostScope_User::clear_minflts()
{ p_validbits &= ~((uint16_t)1U << 3); }

inline bool HostScope_User::has_majflts() const
{ return (0 != (p_validbits & ((uint16_t)1U << 4))); }

inline uint64_t  HostScope_User::majflts() const
{ return m_majflts; }

inline void HostScope_User::clear_majflts()
{ p_validbits &= ~((uint16_t)1U << 4); }

inline bool HostScope_User::has_putime() const
{ return (0 != (p_validbits & ((uint16_t)1U << 5))); }

inline uint32_t  HostScope_User::putime() const
{ return m_putime; }

inline void HostScope_User::clear_putime()
{ p_validbits &= ~((uint16_t)1U << 5); }

inline bool HostScope_User::has_pstime() const
{ return (0 != (p_validbits & ((uint16_t)1U << 6))); }

inline uint32_t  HostScope_User::pstime() const
{ return m_pstime; }

inline void HostScope_User::clear_pstime()
{ p_validbits &= ~((uint16_t)1U << 6); }

inline bool HostScope_User::has_rchars() const
{ return (0 != (p_validbits & ((uint16_t)1U << 7))); }

inline uint32_t  HostScope_User::rchars() const
{ return m_rchars; }

inline void HostScope_User::clear_rchars()
{ p_validbits &= ~((uint16_t)1U << 7); }

inline bool HostScope_User::has_wchars() const
{ return (0 != (p_validbits & ((uint16_t)1U << 8))); }

inline uint32_t  HostScope_User::wchars() const
{ return m_wchars; }

inline void HostScope_User::clear_wchars()
{ p_validbits &= ~((uint16_t)1U << 8); }


inline bool HostScope_Disk::has_devname() const
{ return !m_devname.empty(); }

inline bool HostScope_Disk::has_ktotal() const
{ return (0 != (p_validbits & ((uint8_t)1U << 0))); }

inline uint64_t  HostScope_Disk::ktotal() const
{ return m_ktotal; }

inline void HostScope_Disk::clear_ktotal()
{ p_validbits &= ~((uint8_t)1U << 0); }

inline bool HostScope_Disk::has_nops() const
{ return (0 != (p_validbits & ((uint8_t)1U << 1))); }

inline uint32_t  HostScope_Disk::nops() const
{ return m_nops; }

inline void HostScope_Disk::clear_nops()
{ p_validbits &= ~((uint8_t)1U << 1); }

inline bool HostScope_Disk::has_nread() const
{ return (0 != (p_validbits & ((uint8_t)1U << 2))); }

inline uint32_t  HostScope_Disk::nread() const
{ return m_nread; }

inline void HostScope_Disk::clear_nread()
{ p_validbits &= ~((uint8_t)1U << 2); }

inline bool HostScope_Disk::has_nwrite() const
{ return (0 != (p_validbits & ((uint8_t)1U << 3))); }

inline uint32_t  HostScope_Disk::nwrite() const
{ return m_nwrite; }

inline void HostScope_Disk::clear_nwrite()
{ p_validbits &= ~((uint8_t)1U << 3); }

inline bool HostScope_Disk::has_kread() const
{ return (0 != (p_validbits & ((uint8_t)1U << 4))); }

inline uint32_t  HostScope_Disk::kread() const
{ return m_kread; }

inline void HostScope_Disk::clear_kread()
{ p_validbits &= ~((uint8_t)1U << 4); }

inline bool HostScope_Disk::has_kwrite() const
{ return (0 != (p_validbits & ((uint8_t)1U << 5))); }

inline uint32_t  HostScope_Disk::kwrite() const
{ return m_kwrite; }

inline void HostScope_Disk::clear_kwrite()
{ p_validbits &= ~((uint8_t)1U << 5); }

inline bool HostScope_Disk::has_perc_busy() const
{ return (0 != (p_validbits & ((uint8_t)1U << 6))); }

inline uint32_t  HostScope_Disk::perc_busy() const
{ return m_perc_busy; }

inline void HostScope_Disk::clear_perc_busy()
{ p_validbits &= ~((uint8_t)1U << 6); }

inline bool HostScope_Disk::has_opsqueued() const
{ return (0 != (p_validbits & ((uint8_t)1U << 7))); }

inline uint32_t  HostScope_Disk::opsqueued() const
{ return m_opsqueued; }

inline void HostScope_Disk::clear_opsqueued()
{ p_validbits &= ~((uint8_t)1U << 7); }


inline bool HostScope_NetDevice::has_devname() const
{ return !m_devname.empty(); }

inline bool HostScope_NetDevice::has_nreceived() const
{ return (0 != (p_validbits & ((uint8_t)1U << 0))); }

inline uint32_t  HostScope_NetDevice::nreceived() const
{ return m_nreceived; }

inline void HostScope_NetDevice::clear_nreceived()
{ p_validbits &= ~((uint8_t)1U << 0); }

inline bool HostScope_NetDevice::has_kreceived() const
{ return (0 != (p_validbits & ((uint8_t)1U << 1))); }

inline uint32_t  HostScope_NetDevice::kreceived() const
{ return m_kreceived; }

inline void HostScope_NetDevice::clear_kreceived()
{ p_validbits &= ~((uint8_t)1U << 1); }

inline bool HostScope_NetDevice::has_ereceived() const
{ return (0 != (p_validbits & ((uint8_t)1U << 2))); }

inline uint32_t  HostScope_NetDevice::ereceived() const
{ return m_ereceived; }

inline void HostScope_NetDevice::clear_ereceived()
{ p_validbits &= ~((uint8_t)1U << 2); }

inline bool HostScope_NetDevice::has_dreceived() const
{ return (0 != (p_validbits & ((uint8_t)1U << 3))); }

inline uint32_t  HostScope_NetDevice::dreceived() const
{ return m_dreceived; }

inline void HostScope_NetDevice::clear_dreceived()
{ p_validbits &= ~((uint8_t)1U << 3); }

inline bool HostScope_NetDevice::has_ntransmit() const
{ return (0 != (p_validbits & ((uint8_t)1U << 4))); }

inline uint32_t  HostScope_NetDevice::ntransmit() const
{ return m_ntransmit; }

inline void HostScope_NetDevice::clear_ntransmit()
{ p_validbits &= ~((uint8_t)1U << 4); }

inline bool HostScope_NetDevice::has_ktransmit() const
{ return (0 != (p_validbits & ((uint8_t)1U << 5))); }

inline uint32_t  HostScope_NetDevice::ktransmit() const
{ return m_ktransmit; }

inline void HostScope_NetDevice::clear_ktransmit()
{ p_validbits &= ~((uint8_t)1U << 5); }

inline bool HostScope_NetDevice::has_etransmit() const
{ return (0 != (p_validbits & ((uint8_t)1U << 6))); }

inline uint32_t  HostScope_NetDevice::etransmit() const
{ return m_etransmit; }

inline void HostScope_NetDevice::clear_etransmit()
{ p_validbits &= ~((uint8_t)1U << 6); }

inline bool HostScope_NetDevice::has_dtransmit() const
{ return (0 != (p_validbits & ((uint8_t)1U << 7))); }

inline uint32_t  HostScope_NetDevice::dtransmit() const
{ return m_dtransmit; }

inline void HostScope_NetDevice::clear_dtransmit()
{ p_validbits &= ~((uint8_t)1U << 7); }

inline bool HostScope::has_metadata() const
{ return true; }

inline bool HostScope::has_hostinfo() const
{ return true; }

inline bool HostScope::has_loadavg() const
{ return (0 != (p_validbits & ((uint8_t)1U << 0))); }

inline void HostScope::clear_loadavg()
{ p_validbits &= ~((uint8_t)1U << 0); }

inline bool HostScope::has_mem() const
{ return (0 != (p_validbits & ((uint8_t)1U << 1))); }

inline void HostScope::clear_mem()
{ p_validbits &= ~((uint8_t)1U << 1); }

inline bool HostScope::has_power_supplies() const
{ return !m_power_supplies.empty(); }

inline size_t HostScope::power_supplies_size() const
{ return m_power_supplies.size(); }

inline bool HostScope::has_linux_info() const
{ return (0 != (p_validbits & ((uint8_t)1U << 2))); }

inline void HostScope::clear_linux_info()
{ p_validbits &= ~((uint8_t)1U << 2); }

inline bool HostScope::has_linux_vmstat() const
{ return (0 != (p_validbits & ((uint8_t)1U << 3))); }

inline void HostScope::clear_linux_vmstat()
{ p_validbits &= ~((uint8_t)1U << 3); }

inline bool HostScope::has_linux_cpus() const
{ return !m_linux_cpus.empty(); }

inline size_t HostScope::linux_cpus_size() const
{ return m_linux_cpus.size(); }

inline bool HostScope::has_processes() const
{ return !m_processes.empty(); }

inline size_t HostScope::processes_size() const
{ return m_processes.size(); }

inline bool HostScope::has_users() const
{ return !m_users.empty(); }

inline size_t HostScope::users_size() const
{ return m_users.size(); }

inline bool HostScope::has_disks() const
{ return !m_disks.empty(); }

inline size_t HostScope::disks_size() const
{ return m_disks.size(); }

inline bool HostScope::has_netdevices() const
{ return !m_netdevices.empty(); }

inline size_t HostScope::netdevices_size() const
{ return m_netdevices.size(); }

union mangle_float
{
	explicit mangle_float(float f)
	: f32(f)
	{ }
	
	operator uint32_t () const
	{ return u32; }
	
	float f32;
	uint32_t u32;
};

union mangle_double
{
	explicit mangle_double(double d)
	: f64(d)
	{ }
	
	operator uint64_t () const
	{ return u64; }
	
	double f64;
	uint64_t u64;
};

inline int64_t varint_sint(varint_t v)
{
	uint8_t x = v & 1;
	v >>= 1;
	if (x)
		v = ~v;
	return v;
}

inline uint64_t sint_varint(int64_t i)
{
	return (i << 1) ^ (i >> 63);
}

inline unsigned wiresize_u64(uint64_t u)
{
	unsigned x = 0;
	do ++x;
	while (u>>=7U);
		return x;
}

inline unsigned wiresize_s64(int64_t s)
{
	uint64_t u = (s << 1) ^ (s >> 63);
	return wiresize_u64(u);
}

inline void get_u64(const uint8_t *wire, uint64_t *r)
{
	*r = (uint64_t)wire[0];
	*r |= (uint64_t)wire[1] << 8;
	*r |= (uint64_t)wire[2] << 16;
	*r |= (uint64_t)wire[3] << 24;
	*r |= (uint64_t)wire[4] << 32;
	*r |= (uint64_t)wire[5] << 40;
	*r |= (uint64_t)wire[6] << 48;
	*r |= (uint64_t)wire[7] << 56;
}

inline void get_u32(const uint8_t *wire, uint32_t *r)
{
	*r = (uint32_t)wire[0];
	*r |= (uint32_t)wire[1] << 8;
	*r |= (uint32_t)wire[2] << 16;
	*r |= (uint32_t)wire[3] << 24;
}

inline void get_u16(const uint8_t *wire, uint16_t *r)
{
	*r = (uint16_t)wire[0];
	*r |= (uint16_t)wire[1] << 8;
}

inline unsigned u16_mem(uint8_t *wire, signed wl, uint16_t v)
{
	if (wl < 2)
		return 0;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	return 2;
}

inline unsigned u32_mem(uint8_t *wire, signed wl, uint32_t v)
{
	if (wl < 4)
		return 0;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	return 4;
}

inline unsigned u64_mem(uint8_t *wire, signed wl, uint64_t v)
{
	if (wl < 8)
		return 0;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	v >>= 8;
	*wire++ = v & 0xff;
	return 8;
}

inline unsigned wire2u16(const uint8_t *wire, signed wl, uint16_t *r)
{
	if (wl < 2)
		return 0;
	*r = (uint16_t)wire[0];
	*r |= (uint16_t)wire[1] << 8;
	return 2;
}

inline unsigned wire2u32(const uint8_t *wire, signed wl, uint32_t *r)
{
	if (wl < 4)
		return 0;
	*r = (uint32_t)wire[0];
	*r |= (uint32_t)wire[1] << 8;
	*r |= (uint32_t)wire[2] << 16;
	*r |= (uint32_t)wire[3] << 24;
	return 4;
}

inline unsigned wire2u64(const uint8_t *wire, signed wl, uint64_t *r)
{
	if (wl < 8)
		return 0;
	*r = (uint64_t)wire[0];
	*r |= (uint64_t)wire[1] << 8;
	*r |= (uint64_t)wire[2] << 16;
	*r |= (uint64_t)wire[3] << 24;
	*r |= (uint64_t)wire[4] << 32;
	*r |= (uint64_t)wire[5] << 40;
	*r |= (uint64_t)wire[6] << 48;
	*r |= (uint64_t)wire[7] << 56;
	return 8;
}


inline unsigned u16_wire(void (*put)(uint8_t), uint16_t v)
{
	put(v & 0xff);
	v >>= 8;
	put(v);
	return 2;
}

inline unsigned u32_wire(void (*put)(uint8_t), uint32_t v)
{
	put(v & 0xff);
	v >>= 8;
	put(v & 0xff);
	v >>= 8;
	put(v & 0xff);
	v >>= 8;
	put(v);
	return 4;
}

inline unsigned u64_wire(void (*put)(uint8_t), uint64_t v)
{
	put(v & 0xff);
	v >>= 8;
	put(v & 0xff);
	v >>= 8;
	put(v & 0xff);
	v >>= 8;
	put(v & 0xff);
	v >>= 8;
	put(v & 0xff);
	v >>= 8;
	put(v & 0xff);
	v >>= 8;
	put(v & 0xff);
	v >>= 8;
	put(v);
	return 8;
}

#endif
