/*
 * Copyright 2015, Thomas Maier-Komor
 * LICENSE: GPLv3, see file LICENSE for details
 */

#ifndef LOG_H
#define LOG_H
#include <limits.h>

#ifndef PATH_MAX
#define PATH_MAX _XOPEN_PATH_MAX
#endif

extern int Verbose, Log;
extern unsigned History;

extern void setVerbose(unsigned v);
extern void setLogfile(const char *fn);
extern void log2syslog(const char *exename);
extern void SegVhandler(int signr);
extern void (*DfltSegV)(int signr);
extern char **ARGV;
extern int ARGC;

#ifdef DEBUG
extern void dbug(const char *m, ...);
#elif defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L)
#define dbug(...)
#else
static inline void dbug(const char *m,...) { (void) m; }
#endif

extern void info(const char *m, ...);
extern void warning(const char *m, ...);
extern void warnonce(const char *m, ...);
extern void error(const char *m, ...);
extern void fatal(const char *m, ...);

extern const char *get_msg(int);

#endif
